include longcalc.Inc
IDM_OPEN equ 1
IDM_EXIT equ 2
MAXSIZE equ 260
OUTPUTSIZE equ 512
.data
	ClassName		db "SimpleWinClass",0
	AppName			db "LongCalc",0
	MenuName		db "FirstMenu",0
	ofn				OPENFILENAME <>
	FilterString	db "All Files",0,"*.*",0
					db "Text Files",0,"*.txt",0,0
	buffer			db MAXSIZE dup(0)
	OurTitle		db "-=Our First Open File Dialog Box=-: Choose the file to open",0
	FullPathName	db "The Full Filename with Path is: ",0
	FullName		db "The Filename is: ",0
	ExtensionName	db "The Extension is: ",0
	OutputString	db OUTPUTSIZE dup(0)
	CrLf			db 0Dh,0Ah,0
.data?
	hInstance		HINSTANCE ?
	CommandLine		LPSTR ?
	hWin			HWND ?
.code
start proc <0>
LOCAL ParmArea[4]:QWORD
	invoke GetModuleHandle, NULL
	mov hInstance,rax
	invoke GetCommandLine
	mov CommandLine,rax
	invoke WinMain,hInstance,NULL,CommandLine,SW_SHOWNORMAL
	invoke ExitProcess,eax
start endp
WinMain proc <12,8,8,8,4> hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
LOCAL wc:WNDCLASSEX
LOCAL msg:MSG
	mov wc.cbSize,sizeof WNDCLASSEX
	mov wc.style,CS_HREDRAW or CS_VREDRAW
	mrm wc.lpfnWndProc,&WndProc
	mov wc.cbClsExtra,NULL
	mov wc.cbWndExtra,NULL
	mrm wc.hInstance,hInst
	mov wc.hbrBackground,COLOR_BTNSHADOW+1
	mov wc.lpszMenuName,NULL
	mrm wc.lpszClassName,&ClassName
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov wc.hIcon,rax
	mov wc.hIconSm,rax
	mov wc.hCursor,fn(LoadCursor,NULL,IDC_ARROW)
	invoke RegisterClassEx,&wc
	invoke CreateWindowEx,0,&ClassName,&AppName,WS_OVERLAPPEDWINDOW,dptr 0,\
		dptr 0,dptr 800,dptr 600,0,0,hInst,0
	mov hWin,rax
	invoke ShowWindow,hWin,CmdShow
	invoke UpdateWindow,hWin
	.while TRUE
		invoke GetMessage,&msg,NULL,0,0
		.break .if ~eax
		invoke TranslateMessage,&msg
		invoke DispatchMessage,&msg
	.endw
	mov rax,msg.wParam
	ret
WinMain endp	
WndProc proc <12,8,4,8,8> uses rbx hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
.data
	edit_class				db "edit",0
	edit					textequ <offset edit_class>
	static_class			db "static",0
	static					textequ <offset static_class>
	_default_action_char	db "+",0
	default_action_char		textequ <offset _default_action_char>
	_button_class			db "button",0
	button					textequ <offset _button_class>
	_equal_char				db "=",0
	equal_char				textequ <offset _equal_char>
	_first_arg_caption 		db " ",0
	first_arg_caption		textequ <offset _first_arg_caption>
	_second_arg_caption		db " ",0
	second_arg_caption		textequ <offset _second_arg_caption>
	_result_caption			db "",0
	result_caption			textequ <offset _result_caption>
	_remnant_caption		db "  ",0
	remnant_caption			textequ <offset _remnant_caption>
	_plus					db '+',0
	plus					textequ <offset _plus>
	_minus					db '-',0
	minus					textequ <offset _minus>
	_multiply				db '*',0
	multiply				textequ <offset _multiply>
	_divide					db '/',0
	divide					textequ <offset _divide>
	ADDING					equ 0
	SUBTRACT				equ 1
	DIVIDING				equ 2
	MULTIPLY				equ 3
	align 4
	CurrAction				dd ADDING
.data?
	FirstArgX	HWND ?
	SecArg		HWND ?
	Result		HWND ?
	Remnant		HWND ?
	Clocks		HWND ?
	Action		HWND ?
	DoAction	HWND ?
	SetPlus		HWND ?
	SetMinus	HWND ?
	SetDivide	HWND ?
	SetMul		HWND ?
	hdMath		HANDLE ?
.code
	.if edx==WM_SHOWWINDOW
		invoke CreateWindowEx,0,edit,0,\
			WS_VISIBLE or WS_TABSTOP or WS_CHILD or ES_LEFT or WS_HSCROLL or WS_VSCROLL or ES_MULTILINE,\
			dptr 100,dptr 20,dptr 500,dptr 100,hWin,0,hInstance,0
		mov FirstArgX,rax
		invoke CreateWindowEx,0,edit,0,\
			WS_VISIBLE or WS_TABSTOP or WS_CHILD or ES_LEFT or WS_HSCROLL or WS_VSCROLL or ES_MULTILINE,\
			dptr 100,dptr 140,dptr 500,dptr 100,hWin,0,hInstance,0
		mov SecArg,rax
		invoke CreateWindowEx,0,edit,0,\
			WS_VISIBLE or WS_TABSTOP or WS_CHILD or ES_LEFT or WS_HSCROLL or WS_VSCROLL or ES_MULTILINE,\
			dptr 100,dptr 260,dptr 500,dptr 100,hWin,0,hInstance,0
		mov Result,rax
		invoke CreateWindowEx,0,edit,0,\
			WS_VISIBLE or WS_TABSTOP or WS_CHILD or ES_LEFT or WS_HSCROLL or WS_VSCROLL or ES_MULTILINE,\
			dptr 100,dptr 380,dptr 500,dptr 100,hWin,0,hInstance,0
		mov Remnant,rax
		invoke CreateWindowEx,0,edit,0,WS_VISIBLE or WS_TABSTOP or WS_CHILD or ES_LEFT,\
			dptr 610,dptr 380,dptr 75,dptr 25,hWin,0,hInstance,0
		mov Clocks,rax
		invoke CreateWindowEx,0,static,default_action_char,WS_VISIBLE or WS_CHILD,\
			dptr 70,dptr 115,dptr 30,dptr 30,hWin,0,hInstance,0
		mov Action,rax
		invoke CreateWindowEx,0,button,equal_char,WS_VISIBLE or WS_CHILD,\
			dptr 67,dptr 290,dptr 30,dptr 30,hWin,0,hInstance,0
		mov DoAction,rax
		invoke CreateWindowEx,0,button,minus,WS_VISIBLE or WS_CHILD,\
			dptr 67,dptr 490,dptr 30,dptr 30,hWin,0,hInstance,0
		mov SetMinus,rax
		invoke CreateWindowEx,0,button,plus,WS_VISIBLE or WS_CHILD,\
			dptr 34,dptr 490,dptr 30,dptr 30,hWin,0,hInstance,0
		mov SetPlus,rax
		invoke CreateWindowEx,0,button,divide,WS_VISIBLE or WS_CHILD,\
			dptr 100,dptr 490,dptr 30,dptr 30,hWin,0,hInstance,0
		mov SetDivide,rax
		invoke CreateWindowEx,0,button,multiply,WS_VISIBLE or WS_CHILD,\
			dptr 133,dptr 490,dptr 30,dptr 30,hWin,0,hInstance,0
		mov SetMul,rax
		invoke CreateWindowEx,0,static,first_arg_caption,WS_VISIBLE or WS_CHILD,\
			dptr 20,dptr 40,dptr 70,dptr 35,hWin,0,hInstance,0
		invoke CreateWindowEx,0,static,second_arg_caption,WS_VISIBLE or WS_CHILD,\
			dptr 20,dptr 160,dptr 70,dptr 35,hWin,0,hInstance,0
		invoke CreateWindowEx,0,static,result_caption,WS_VISIBLE or WS_CHILD,\
			dptr 20,dptr 265,dptr 70,dptr 20,hWin,0,hInstance,0
		invoke CreateWindowEx,0,static,remnant_caption,WS_VISIBLE or WS_CHILD,\
			dptr 20,dptr 395,dptr 70,dptr 50,hWin,0,hInstance,0
		invoke init_calc,16,',',16
		mov hdMath,rax
	.elseif edx==WM_COMMAND
		mov rax,lParam
		.if rax==DoAction
			mov rbx,hdMath
			invoke GetWindowText,FirstArgX,[rbx][CALC_DESCRIPTOR.ascii_buff],[rbx][CALC_DESCRIPTOR.size_abuff]
			invoke fmtator,hdMath,[rbx][CALC_DESCRIPTOR.reg0],10
			invoke GetWindowText,SecArg,[rbx][CALC_DESCRIPTOR.ascii_buff],[rbx][CALC_DESCRIPTOR.size_abuff]
			invoke fmtator,rbx,[rbx][CALC_DESCRIPTOR.reg1],10
			.if CurrAction==ADDING
				invoke int_add,rbx,[rbx][CALC_DESCRIPTOR.reg0],[rbx][CALC_DESCRIPTOR.reg1]
			.elseif CurrAction==SUBTRACT
				invoke int_sub,rbx,[rbx][CALC_DESCRIPTOR.reg0],[rbx][CALC_DESCRIPTOR.reg1]
			.elseif CurrAction==DIVIDING
				rdtsc
				shl rdx,32
				or eax,eax
				or rax,rdx
				mov lParam,rax
				invoke uint_div,rbx,[rbx][CALC_DESCRIPTOR.reg0],[rbx][CALC_DESCRIPTOR.reg1],0
				rdtsc
				shl rdx,32
				or eax,eax
				or rax,rdx
				sub rax,lParam
				.data
					pat_clock db '%I64X',0
					str_clock db 256 dup(0)
				.code
				invoke wsprintf,&str_clock,&pat_clock,rax
				invoke SetWindowText,Clocks,&str_clock
				invoke itoaX,rbx,[rbx][CALC_DESCRIPTOR.msr0],10
				invoke SetWindowText,Remnant,[rbx][CALC_DESCRIPTOR.ascii_buff]
			.elseif CurrAction==MULTIPLY
				rdtsc
				shl rdx,32
				or eax,eax
				or rax,rdx
				mov lParam,rax
				invoke uint_mul,rbx,[rbx][CALC_DESCRIPTOR.reg0],[rbx][CALC_DESCRIPTOR.reg1]
				rdtsc
				shl rdx,32
				or eax,eax
				or rax,rdx
				sub rax,lParam
			.endif
			;invoke itoaX,hdMath,[ebx].reg0,10
			;invoke rtoaX,hdMath,[ebx].reg0,10
			invoke fmtrtoa,rbx,[rbx][CALC_DESCRIPTOR.reg0],10,20
			invoke SetWindowText,Result,[rbx][CALC_DESCRIPTOR.ascii_buff]
		.elseif rax==SetMinus
			mov CurrAction,SUBTRACT
			invoke SetWindowText,Action,minus
		.elseif rax==SetPlus
			mov CurrAction,ADDING
			invoke SetWindowText,Action,plus
		.elseif rax==SetDivide
			mov CurrAction,DIVIDING
			invoke SetWindowText,Action,divide
		.elseif rax==SetMul
			mov CurrAction,MULTIPLY
			invoke SetWindowText,Action,multiply
		.endif
	.elseif edx==WM_DESTROY
		invoke off_calc,hdMath
		invoke PostQuitMessage,NULL
	.else
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		ret
	.endif
	xor eax,eax
	ret
WndProc endp
end