.686
.model flat,stdcall
option casemap:none
include calcinc.inc
.code
DllEntryPoint proc hInst,Reason,Reserv
	mov eax,1
	ret
DllEntryPoint endp
;--------------------------------------------------------------------------------
init_calc proc int_length,decseparator,fract_length
	mov eax,int_length
	add eax,fract_length
	shl eax,2
	mov ecx,eax
	shl ecx,3
	add ecx,2
	push ecx
	shl eax,4
	lea eax,[eax+ecx+sizeof CALC_DESCRIPTOR]
	push eax
	invoke VirtualAlloc,NULL,eax,MEM_COMMIT,PAGE_EXECUTE_READWRITE
	pop [eax][CALC_DESCRIPTOR.calc_size]
	pop [eax][CALC_DESCRIPTOR.size_abuff]
	mov ecx,int_length
	mov [eax][CALC_DESCRIPTOR.int_length],ecx
	mov edx,fract_length
	mov [eax][CALC_DESCRIPTOR.fract_length],edx
	add ecx,edx
	shl ecx,2
	mov edx,eax
	add edx,sizeof CALC_DESCRIPTOR
	mov [eax][CALC_DESCRIPTOR.reg0],edx
	add edx,ecx
	mov [eax][CALC_DESCRIPTOR.reg1],edx
	add edx,ecx
	mov [eax][CALC_DESCRIPTOR.reg2],edx
	add edx,ecx
	mov [eax][CALC_DESCRIPTOR.reg3],edx
	add edx,ecx
	mov [eax][CALC_DESCRIPTOR.reg4],edx
	add edx,ecx
	mov [eax][CALC_DESCRIPTOR.reg5],edx
	add edx,ecx
	mov [eax][CALC_DESCRIPTOR.reg6],edx
	add edx,ecx
	mov [eax][CALC_DESCRIPTOR.reg7],edx
	add edx,ecx
	mov [eax][CALC_DESCRIPTOR.msr0],edx
	add edx,ecx
	mov [eax][CALC_DESCRIPTOR.msr1],edx
	add edx,ecx
	mov [eax][CALC_DESCRIPTOR.msr2],edx
	add edx,ecx
	mov [eax][CALC_DESCRIPTOR.msr3],edx
	add edx,ecx
	mov [eax][CALC_DESCRIPTOR.msr4],edx
	add edx,ecx
	mov [eax][CALC_DESCRIPTOR.msr5],edx
	add edx,ecx
	mov [eax][CALC_DESCRIPTOR.msr6],edx
	add edx,ecx
	mov [eax][CALC_DESCRIPTOR.msr7],edx
	add edx,ecx
	mov [eax][CALC_DESCRIPTOR.ascii_buff],edx
	mov edx,decseparator
	mov [eax][CALC_DESCRIPTOR.DecimalSeparator],dl
	ret
init_calc endp
off_calc proc hMath
	mov eax,hMath
	mov edx,[eax][CALC_DESCRIPTOR.calc_size]
	invoke VirtualFree,eax,edx,MEM_DECOMMIT
	ret
off_calc endp
;--------------------------------------------------------------------------------
;    x1=x1+x2
uint_add proc uses ebx esi edi hCalc,x1,x2
LOCAL m	;    DWORD`ax
LOCAL n	;    DWORD`ax
LOCAL dmn	;   |m-n|
	mov ebx,hCalc
	mov [ebx][CALC_DESCRIPTOR.ErrFlags],FALSE	;   
	mov edi,x1
	mov esi,x2
	mov eax,[edi]
	mov ecx,[esi]
	and eax,7FFFFFFFh
	.if ZERO?	;    
		and ecx,7FFFFFFFh
		.if !ZERO?	;     
			and dword ptr [edi],80000000h
			or [edi],ecx
			mov edx, [ebx][CALC_DESCRIPTOR.int_length]
			sub edx,ecx
			lea edi,[edi+4*edx]
			lea esi,[esi+4*edx]
			rep movsd
			inc eax
		.endif
		ret
	.endif
	and ecx,7FFFFFFFh
	.if !ZERO?	;        
		mov m,eax
		mov n,ecx
		mov edx,ecx
		sub edx,eax
		.repeat
			neg edx
		.until !SIGN?
		mov dmn,edx
		cmp eax,ecx		; ecx 
		cmovb ecx,eax	;ecx==min[eax,ecx]
		mov eax,[ebx][CALC_DESCRIPTOR.int_length]
		sub eax,ecx
		lea esi,[esi+4*eax-4]
		lea edi,[edi+4*eax-4]
		clc
		.repeat	;  
			mov eax,[esi+4*ecx]
			adc [edi+4*ecx],eax
		.untilcxz
		.if CARRY?	;    
			mov eax,m
			.if eax>=n
				.if ZERO?
					.if edi>x1
						mov dword ptr [edi],1
					.else	;  
						or [ebx][CALC_DESCRIPTOR.ErrFlags],OVERFLOW_FLAG
					.endif
				.else
					mov ecx,dmn
					lea eax,[4*ecx]
					sub edi,eax
					stc
				@@:
					adc dword ptr [edi+4*ecx],0
					loope @B
					.if CARRY?
						.if edi>x1
							mov dword ptr [edi],1
						.else	;  
							or [ebx][CALC_DESCRIPTOR.ErrFlags],OVERFLOW_FLAG
						.endif
					.endif
				.endif
			.else
				mov ecx,dmn
				lea eax,[4*ecx]
				sub edi,eax
				sub esi,eax
				stc
			@@:
				mov eax,dword ptr [esi+4*ecx]
				adc dword ptr [edi+4*ecx],eax
				loope @B
				.if CARRY?
					.if edi>x1
						mov dword ptr [edi],1
					.else	;  
						or [ebx][CALC_DESCRIPTOR.ErrFlags],OVERFLOW_FLAG
					.endif
				.endif
				jecxz @F
				add edi,4
				add esi,4
				rep movsd
				mov ecx,dmn
				lea eax,[4*ecx]
				sub edi,eax
				sub edi,4
			@@:
			.endif
		.else	;     
			mov eax,m
			.if eax>=n
				mov ecx,dmn
				lea eax,[4*ecx]
				sub edi,eax 
			.else
				mov ecx,dmn
				lea eax,[4*ecx-4]
				sub edi,eax
				sub esi,eax
				rep movsd
				sub edi,eax
				sub edi,4
			.endif
		.endif
		mov esi,x1
		.if edi<=esi
			lea edi,[esi+4]
		.endif
		mov eax,[ebx][CALC_DESCRIPTOR.int_length]
		lea eax,[edi+4*eax-4]
		.while !(dword ptr [edi]) && edi<eax
			add edi,4
		.endw
		sub edi,esi
		shr edi,2
		mov ecx,[ebx][CALC_DESCRIPTOR.int_length]
		sub ecx,edi
		and dword ptr [esi],80000000h
		or dword ptr [esi],ecx
	.endif
	ret
uint_add endp
;    x1=x1-x2
uint_sub proc uses ebx esi edi hCalc,x1,x2
	mov ebx,hCalc
	mov ecx,[ebx][CALC_DESCRIPTOR.int_length]
	mov [ebx][CALC_DESCRIPTOR.ErrFlags],0
	mov edi,x1
	mov esi,x2
	mov edx,[esi]
	and edx,7FFFFFFFh
	jz Exit
	sub ecx,edx
	lea esi,[esi+4*ecx-4]
	lea edi,[edi+4*ecx-4]
	mov ecx,edx
	clc
	.repeat
		mov eax,dword ptr [esi+4*ecx]
		sbb dword ptr [edi+4*ecx],eax
	.untilcxz
	mov ecx,x1
	.if CARRY?
		mov edx,edi
		mov ecx,edi
		sub ecx,x1
		shr ecx,2
		stc
		.repeat
			sbb dword ptr [edi],0
			lea edi,[edi-4]
			lea ecx,[ecx-1]
			jecxz @F
		.until !CARRY?
	@@:	
		.if CARRY?
			or [ebx][CALC_DESCRIPTOR.ErrFlags],OVERFLOW_FLAG
		.endif
		mov ecx,x1
	.endif
	mov edx,ecx
	.repeat
		add ecx,4
	.until dword ptr [ecx]
	sub ecx,x1
	shr ecx,2
	mov eax,[ebx][CALC_DESCRIPTOR.int_length]
	sub eax,ecx
	and dword ptr [edx],80000000h
	or [edx],eax
Exit:
	ret
uint_sub endp
comment *   W=[U/V]
S1.  r=0 j=n-1
S2.  W[ j ]=[(rb+U[ j ])/V], r=(rb+U[ j ]) mod V
S3.  j  ,   j>=0    S2
b=2^32, W - , edx - *
ShortDivUx proc uses edi esi ebx hCalc,W,V
	mov ebx,hCalc
	mov edi,W
	mov esi,edi
	mov ecx,[edi]
	and ecx,7FFFFFFFh
	jz Exit
	mov edx,[ebx][CALC_DESCRIPTOR.int_length]
	sub edx,ecx
	lea edi,[edi+4*edx]
	xor edx,edx
	mov ebx,V
	mov eax,[edi]
	div ebx
	.if !eax
		dec dword ptr [esi]
	.endif
	mov [edi],eax
	add edi,4
	dec ecx
	jz Exit
s2:	mov eax,[edi]
	div ebx
	mov [edi],eax
	add edi,4
s3:	loop s2
Exit:
	ret
ShortDivUx endp
ShortRDiv proc uses edi esi ebx hCalc,W,V
	mov ebx,hCalc
	mov edi,W
	mov esi,edi
	mov ecx,[edi]
	and ecx,7FFFFFFFh
	.if !ZERO?
		mov edx,[ebx][CALC_DESCRIPTOR.int_length]
		sub edx,ecx
		lea edi,[edi+4*edx]
		add ecx,[ebx][CALC_DESCRIPTOR.fract_length]
		xor edx,edx
		mov ebx,V
		mov eax,[edi]
		div ebx
		.if !eax
			dec dword ptr [esi]
		.endif
		mov [edi],eax
		add edi,4
		dec ecx
		jz Exit
	.else
		mov edx,[ebx][CALC_DESCRIPTOR.int_length]
		lea edi,[edi+4*edx]
		xor eax,eax
		mov ecx,[ebx][CALC_DESCRIPTOR.fract_length]
		inc ecx
		sub edi,4
		xor edx,edx
		mov ebx,V
	.endif
s2:	mov eax,[edi]
	div ebx
	mov [edi],eax
	add edi,4
s3:	loop s2	
Exit:
	ret
ShortRDiv endp
ShortRMul proc uses edi esi ebx hCalc,W,V
	mov ebx,hCalc
	mov eax,[ebx][CALC_DESCRIPTOR.int_length]
	mov edi,W
	mov ecx,[edi]
	and ecx,7FFFFFFFh
	sub eax,ecx
	lea edi,[edi+4*eax-4]
	add ecx,[ebx][CALC_DESCRIPTOR.fract_length]
	mov ebx,V
	xor esi,esi
	.repeat
		mov eax,dword ptr [edi+4*ecx]
		mul ebx
		add eax,esi
		adc edx,0
		mov esi,edx
		mov dword ptr [edi+4*ecx],eax
	.untilcxz
	.if !ZERO?
		.if edi==W
			mov eax,edx
		.else
			xor eax,eax
			mov [edi],edx
			mov ecx,W
			inc dword ptr [ecx]
		.endif
		ret
	.endif
	xor eax,eax
	ret
ShortRMul endp
comment *  *
ShortMulUx proc uses edi esi ebx hMath,W,V
	mov ecx,hMath
	mov eax,[ecx][CALC_DESCRIPTOR.int_length]
	mov edi,W
	mov ecx,[edi]
	and ecx,7FFFFFFFh
	.if !ZERO?
		sub eax,ecx
		lea edi,[edi+4*eax-4]
		mov ebx,V
		xor esi,esi
		.repeat
			mov eax,dword ptr [edi+4*ecx]
			mul ebx
			add eax,esi
			adc edx,0
			mov esi,edx
			mov dword ptr [edi+4*ecx],eax
		.untilcxz
		.if !ZERO?
			.if edi==W
				mov eax,edx
			.else
				xor eax,eax
				mov [edi],edx
				mov ecx,W
				inc dword ptr [ecx]
			.endif
			ret
		.endif
	.endif
	xor eax,eax
	ret
ShortMulUx endp
;--------------------------------------------------------------------------------
;     
; X - 
; Radix -   
;msr0
itoaX proc uses esi edi ebx hMath,X,Radix
LOCAL pAscii,dwCount,Cnt,Signum
	mov ebx,hMath
assume ebx:ptr CALC_DESCRIPTOR
	mov ecx,[ebx].ascii_buff
	add ecx,[ebx].size_abuff
	sub ecx,2
	mov byte ptr [ecx+1],0
	mov pAscii,ecx
	mov Cnt,ecx
	mov ecx,[ebx].int_length
	mov edi,X
	mov eax,[edi]
	mov Signum,eax
	and eax,7FFFFFFFh
	.if ZERO?
		mov eax,pAscii
		mov byte ptr [eax],'0'
	.else
		sub ecx,eax
		lea esi,[edi+4*ecx]
		mov ecx,eax
		mov dwCount,ecx
		mov edi,[ebx].msr0
		mov edx,edi
		rep movsd
		mov edi,edx
		mov esi,edx
		.repeat
			mov ecx,dwCount
			xor edx,edx
			.repeat
				mov eax,dword ptr [edi]
				div Radix
				mov dword ptr [edi],eax
				add edi,4
			.untilcxz
			.if dl>9
				add dl,7
			.endif
			add dl,'0'
			mov ecx,pAscii
			dec pAscii
			mov [ecx],dl
			.if !(dword ptr [esi])
				add esi,4
				dec dwCount
			.endif
			mov edi,esi
		.until ZERO?
		mov eax,pAscii
		inc eax
	.endif
	mov edi,X
	.if Signum&80000000h
		dec eax
		mov byte ptr [eax],'-'
	.endif
	sub Cnt,eax
	.if eax>[ebx].ascii_buff
		invoke lstrcpy,[ebx].ascii_buff,eax
	.endif
	mov edx,Cnt
assume ebx:nothing
	ret
itoaX endp
;--------------------------------------------------------------------------------
; c     
; X - 
; Radix -   
atoiX proc uses edi esi ebx hMath,X,Radix
	mov ebx,hMath
	mov esi,[ebx][CALC_DESCRIPTOR.ascii_buff]
	mov ebx,[ebx][CALC_DESCRIPTOR.int_length]
	xor eax,eax
	mov edi,X
	mov ecx,ebx
	rep stosd
	mov edx,X
	.if byte ptr [esi]=='-'
		or dword ptr [edx],80000000h
		inc esi
	.endif
	.if byte ptr [esi]!='0'
		inc dword ptr [edx]
	.else
		lea eax,[esi+1]
		ret
	.endif
	.while TRUE
		movzx edx,byte ptr [esi]
		.if dl>='0' && dl<='9'
			and dl,0Fh
		.elseif dl>='A' && dl<='Z'
			sub dl,37h
		.else
			.break
		.endif
		push edx
		invoke ShortMulUx,hMath,X,Radix
		pop edx
		mov edi,X
		mov ecx,[edi]
		and ecx,7FFFFFFFh
		inc ecx
		lea eax,[4*ecx]
		lea edi,[edi+4*ebx-4]
		sub edi,eax
		add dword ptr [edi+4*ecx],edx
		dec ecx
	@@:
		adc dword ptr [edi+4*ecx],0
		loope @B
		inc esi
		jecxz @F
		.continue
	@@:
		.if dword ptr [edi+4]==1
			mov edi,X
			inc dword ptr [edi]
		.endif
	.endw
	mov eax,esi
	ret
atoiX endp
rtoaX proc uses edi esi ebx hCalc,X,Radix
LOCAL pAscii,MaxAscii,pFract,SizeFract
	invoke itoaX,hCalc,X,Radix
	push eax
	lea eax,[eax+edx+1]
	mov pAscii,eax
	mov ebx,hCalc
	.if ![ebx][CALC_DESCRIPTOR.fract_length]
		pop eax
		ret
	.endif
	mov ecx,[ebx][CALC_DESCRIPTOR.size_abuff]
	sub ecx,edx
	dec ecx
	mov MaxAscii,ecx
	mov esi,X
	mov ecx,[ebx][CALC_DESCRIPTOR.int_length]
	lea esi,[esi+4*ecx]
	mov edi,[ebx][CALC_DESCRIPTOR.msr0]
	sub edi,4
	mov pFract,edi
	add edi,4
	mov ecx,[ebx][CALC_DESCRIPTOR.fract_length]
	mov SizeFract,ecx
	rep movsd
	.repeat
		sub edi,4
		.if !(dword ptr [edi])
			dec SizeFract
			jz Exit
		.else
			.break
		.endif
	.until ZERO?
	mov dl,[ebx][CALC_DESCRIPTOR.DecimalSeparator]
	mov byte ptr [eax],dl
	inc pAscii
	dec MaxAscii
	mov ecx,SizeFract
	shl ecx,5
	xchg MaxAscii,ecx
	fild MaxAscii
	fld1
	fild Radix
	fyl2x
	fdivp st(1),st(0)
	frndint
	fistp MaxAscii
	.if MaxAscii>ecx
		mov MaxAscii,ecx
	.endif
	mov edi,pFract
	mov ebx,Radix
	.repeat
		mov ecx,SizeFract
		xor esi,esi
		.repeat
			mov eax,dword ptr [edi+4*ecx]
			mul ebx
			add eax,esi
			adc edx,0
			mov esi,edx
			mov dword ptr [edi+4*ecx],eax
		.untilcxz
		.if dl>9
			add dl,7
		.endif
		add dl,30h
		mov eax,pAscii
		inc pAscii
		mov byte ptr [eax],dl
		dec MaxAscii
	.until ZERO?
	mov eax,pAscii
	mov byte ptr [eax],0
Exit:	
	pop eax
	ret
rtoaX endp
atorX proc uses esi edi ebx hCalc,X,Radix
LOCAL pAscii,pFract
	invoke atoiX,hCalc,X,Radix
	mov ebx,hCalc
	mov dl,[ebx][CALC_DESCRIPTOR.DecimalSeparator]
	.if byte ptr [eax]==dl && [ebx][CALC_DESCRIPTOR.fract_length]
		mov pAscii,eax
		mov edi,eax
		or ecx,-1
		mov al,'e'
		.while byte ptr [edi] && al!=byte ptr [edi]
			inc edi
		.endw
		xor eax,eax
		lea esi,[edi-1]
		mov edi,X
		mov edx,[ebx][CALC_DESCRIPTOR.int_length]
		lea edi,[edi+4*edx]
		mov ecx,[ebx][CALC_DESCRIPTOR.fract_length]
		mov pFract,edi
		rep stosd
		.repeat
			movzx edx,byte ptr [esi]
			.if dl>='A' && dl<='F'
				sub dl,7
			.endif
			sub dl,30h
			mov edi,pFract
			mov ecx,[ebx][CALC_DESCRIPTOR.fract_length]
			.repeat
				mov eax,[edi]
				div Radix
				mov [edi],eax
				add edi,4
			.untilcxz
			dec esi
		.until esi==pAscii
	.else
		mov edi,X
		mov ecx,[ebx][CALC_DESCRIPTOR.int_length]
		lea edi,[edi+4*ecx]
		mov ecx,[ebx][CALC_DESCRIPTOR.fract_length]
		xor eax,eax
		rep stosd
	.endif
	ret
atorX endp
;  64-     edx:eax
ild proc uses ebx edi  esi hCalc,X
	mov ebx,hCalc
	mov esi,[ebx][CALC_DESCRIPTOR.int_length]
	mov edi,X
	mov ecx,[edi]
	and ecx,7FFFFFFFh
	sub esi,ecx
	lea edi,[edi+4*esi]
	mov esi,eax
	xor eax,eax
	rep stosd
	xchg eax,esi
	test edx,edx
	.if SIGN?
		mov esi,80000000h
		neg edx
		neg eax
		sbb edx,0
	.endif
	.if !ZERO?
		or esi,10b
	.elseif eax
		or esi,1
	.endif
	mov [edi-4],eax
	mov [edi-8],edx
	mov ecx,[ebx][CALC_DESCRIPTOR.fract_length]
	jecxz @F
	xor eax,eax
	rep stosd
@@:
	mov edi,X
	mov [edi],esi
	ret
ild endp
;   64-     edx:eax
uild proc uses ebx edi  esi hCalc,X
	mov ebx,hCalc
	mov ebx,[ebx][CALC_DESCRIPTOR.int_length]
	mov esi,ebx
	mov edi,X
	mov ecx,[edi]
	and ecx,7FFFFFFFh
	sub esi,ecx
	lea edi,[edi+4*esi]
	mov esi,eax
	xor eax,eax
	rep stosd
	.if edx
		or eax,10b
	.elseif esi
		or eax,1
	.endif
	mov [edi-4],esi
	mov [edi-8],edx
	mov ebx,hCalc
	mov ecx,[ebx][CALC_DESCRIPTOR.fract_length]
	mov esi,eax
	jecxz @F
	xor eax,eax
	rep stosd
@@:
	mov edi,X
	mov [edi],esi
	ret
uild endp
;     ר 
int_mul proc uses edi esi ebx hCalc,X1,X2
LOCAL m,n,signum,result,mprs,svEsp
	mov ebx,hCalc
	mov [ebx][CALC_DESCRIPTOR.ErrFlags],0
	mov ecx,[ebx][CALC_DESCRIPTOR.int_length]
	mov edi,[ebx][CALC_DESCRIPTOR.msr0]
	shl ecx,1
	xor eax,eax	;    
	rep stosd
	sub edi,4
	mov result,edi
	mov edi,X1
	mov eax,[edi]
	mov esi,X2
	mov edx,[esi]
	mov ecx,edx
	xor ecx,eax
	and ecx,80000000h
	mov signum,ecx
	and eax,7FFFFFFFh
	jz Exit
	and edx,7FFFFFFFh
	jz movz
	mov m,eax
	mov n,edx
	mov ecx,[ebx][CALC_DESCRIPTOR.int_length]
	lea edx,[esi+4*ecx-4]
	mov mprs,edx
	sub ecx,eax
	lea edi,[edi+4*ecx-4]
	mov ebx,result
	shl eax,2
	sub ebx,eax
	mulm m,n,mprs,svEsp	; 
	mov edx,result
	add edx,4
	sub edx,ebx
	shr edx,2
	mov edi,X1
	mov ebx,hCalc
	mov ecx,[ebx][CALC_DESCRIPTOR.int_length]
	xor eax,eax
	rep stosd
	std
	sub edi,4
	mov esi,result
	mov ecx,edx
	mov eax,[ebx][CALC_DESCRIPTOR.int_length]
	.if edx<eax
		mov eax,edx
	.else
		or [ebx][CALC_DESCRIPTOR.ErrFlags],OVERFLOW_FLAG
		dec eax
		mov ecx,eax
	.endif
	rep movsd
	cld
	or edx,signum
	or eax,signum
	mov edi,X1
	mov [edi],eax
	mov edi,[ebx][CALC_DESCRIPTOR.msr0]
	mov [edi],edx
Exit:
	ret
movz:
	mov edi,X1
	mov ecx,[ebx][CALC_DESCRIPTOR.int_length]
	xor eax,eax
	rep stosd
	ret
int_mul endp
recalcpi proc uses edi esi ebx hCalc,ppi,prec_pi
LOCAL h
	mov h,1
	mov ebx,hCalc
	mov edi,ppi
	mov ecx,[ebx][CALC_DESCRIPTOR.int_length]
	add ecx,[ebx][CALC_DESCRIPTOR.fract_length]
	xor eax,eax
	rep stosd
	mov edi,[ebx][CALC_DESCRIPTOR.msr0]
	xor eax,eax
	mov ecx,[ebx][CALC_DESCRIPTOR.int_length]
	rep stosd
	mov eax,16
	xor edx,edx
	invoke uild,hCalc,[ebx][CALC_DESCRIPTOR.msr0]
	mov eax,4
	xor edx,edx
	invoke uild,hCalc,[ebx][CALC_DESCRIPTOR.msr1]
	xor eax,eax
	xor edx,edx
	invoke uild,hCalc,ppi
	invoke ShortRDiv,ebx,[ebx][CALC_DESCRIPTOR.msr0],5
	invoke ShortRDiv,ebx,[ebx][CALC_DESCRIPTOR.msr1],239
	invoke ureal_add,ebx,ppi,[ebx][CALC_DESCRIPTOR.msr0]
	invoke ureal_sub,ebx,ppi,[ebx][CALC_DESCRIPTOR.msr1]
	.repeat
		add h,2
		invoke ShortRDiv,ebx,[ebx][CALC_DESCRIPTOR.msr0],25
		invoke ShortRDiv,ebx,[ebx][CALC_DESCRIPTOR.msr1],57121
		mov edi,[ebx][CALC_DESCRIPTOR.msr2]
		mov esi,[ebx][CALC_DESCRIPTOR.msr0]
		mov ecx,[ebx][CALC_DESCRIPTOR.int_length]
		add ecx,[ebx][CALC_DESCRIPTOR.fract_length]
		rep movsd
		mov edi,[ebx][CALC_DESCRIPTOR.msr3]
		mov esi,[ebx][CALC_DESCRIPTOR.msr1]
		mov ecx,[ebx][CALC_DESCRIPTOR.int_length]
		add ecx,[ebx][CALC_DESCRIPTOR.fract_length]
		rep movsd
		invoke ShortRDiv,ebx,[ebx][CALC_DESCRIPTOR.msr2],h
		invoke ShortRDiv,ebx,[ebx][CALC_DESCRIPTOR.msr3],h
		invoke ureal_sub,ebx,ppi,[ebx][CALC_DESCRIPTOR.msr2]
		invoke ureal_add,ebx,ppi,[ebx][CALC_DESCRIPTOR.msr3]
		add h,2
		invoke ShortRDiv,ebx,[ebx][CALC_DESCRIPTOR.msr0],25
		invoke ShortRDiv,ebx,[ebx][CALC_DESCRIPTOR.msr1],57121
		mov edi,[ebx][CALC_DESCRIPTOR.msr2]
		mov esi,[ebx][CALC_DESCRIPTOR.msr0]
		mov ecx,[ebx][CALC_DESCRIPTOR.int_length]
		add ecx,[ebx][CALC_DESCRIPTOR.fract_length]
		rep movsd
		mov edi,[ebx][CALC_DESCRIPTOR.msr3]
		mov esi,[ebx][CALC_DESCRIPTOR.msr1]
		mov ecx,[ebx][CALC_DESCRIPTOR.int_length]
		add ecx,[ebx][CALC_DESCRIPTOR.fract_length]
		rep movsd
		invoke ShortRDiv,ebx,[ebx][CALC_DESCRIPTOR.msr2],h
		invoke ShortRDiv,ebx,[ebx][CALC_DESCRIPTOR.msr3],h
		invoke ureal_add,ebx,ppi,[ebx][CALC_DESCRIPTOR.msr2]
		invoke ureal_sub,ebx,ppi,[ebx][CALC_DESCRIPTOR.msr3]
		mov eax,prec_pi
	.until h>=eax
	ret
recalcpi endp
ureal_add proc uses esi edi ebx hCalc,x1,x2
LOCAL m,n,dmn
	mov ebx,hCalc
	mov [ebx][CALC_DESCRIPTOR.ErrFlags],0
	mov edi,x1
	mov esi,x2
	mov eax,[edi]
	and eax,7FFFFFFFh
	add eax,[ebx][CALC_DESCRIPTOR.fract_length]
	mov edx,[esi]
	and edx,7FFFFFFFh
	add edx,[ebx][CALC_DESCRIPTOR.fract_length]
	mov m,eax
	mov n,edx
	mov ecx,edx
	sub edx,eax
	.repeat
		neg edx
	.until !SIGN?
	mov dmn,edx
	cmp eax,ecx
	cmovb ecx,eax
	mov eax,[ebx][CALC_DESCRIPTOR.int_length]
	add eax,[ebx][CALC_DESCRIPTOR.fract_length]
	sub eax,ecx
	lea esi,[esi+4*eax-4]
	lea edi,[edi+4*eax-4]
	clc
	.repeat
		mov eax,dword ptr [esi+4*ecx]
		adc dword ptr [edi+4*ecx],eax
	.untilcxz
	.if CARRY?
		mov eax,m
		.if eax>=n
			.if ZERO?
				.if edi>x1
					mov dword ptr [edi],1
				.else
					or [ebx][CALC_DESCRIPTOR.ErrFlags],OVERFLOW_FLAG
				.endif
			.else
				mov ecx,dmn
				lea eax,[4*ecx]
				sub edi,eax
				stc
			@@:
				adc dword ptr [edi+4*ecx],0
				loope @B
				.if CARRY?
					.if edi>x1
						mov dword ptr [edi],1
					.else
						or [ebx][CALC_DESCRIPTOR.ErrFlags],OVERFLOW_FLAG
					.endif
				.endif
			.endif
		.else
			mov ecx,dmn
			lea eax,[4*ecx]
			sub edi,eax
			sub esi,eax
			stc
		@@:
			mov eax,dword ptr [esi+4*ecx]
			adc dword ptr [edi+4*ecx],eax
			loope @B
			.if CARRY?
				.if edi>x1
					mov dword ptr [edi],1
				.else
					or [ebx][CALC_DESCRIPTOR.ErrFlags],OVERFLOW_FLAG
				.endif
			.endif
			jecxz @F
			add edi,4
			add esi,4
			rep movsd
			mov ecx,dmn
			lea eax,[4*ecx]
			sub edi,eax
			sub edi,4
		@@:
		.endif
	.else
		mov eax,m
		.if eax>=n
			mov ecx,dmn
			lea eax,[4*ecx]
			sub edi,eax 
		.else
			mov ecx,dmn
			lea eax,[4*ecx]
			sub edi,eax
			sub esi,eax
			add edi,4
			add esi,4
			rep movsd
			sub edi,eax
			sub edi,4
		.endif
	.endif
	mov esi,x1
	.if edi<=esi
		lea edi,[esi+4]
	.endif
	mov eax,[ebx][CALC_DESCRIPTOR.int_length]
	lea eax,[esi+4*eax]
	.if edi>=eax
		mov edi,eax
	.else
		.while !(dword ptr [edi]) && edi<eax
			add edi,4
		.endw
	.endif
	sub edi,esi
	shr edi,2
	mov ecx,[ebx][CALC_DESCRIPTOR.int_length]
	sub ecx,edi
	and dword ptr [esi],80000000h
	or [esi],ecx
Exit:
	ret
ureal_add endp

ureal_sub proc uses esi edi ebx hCalc,x1,x2
	mov ebx,hCalc
	mov ecx,[ebx][CALC_DESCRIPTOR.int_length]
	mov [ebx][CALC_DESCRIPTOR.ErrFlags],0
	mov edi,x1
	mov esi,x2
	mov edx,[esi]
	and edx,7FFFFFFFh
	sub ecx,edx
	add edx,[ebx][CALC_DESCRIPTOR.fract_length]
	lea esi,[esi+4*ecx-4]
	lea edi,[edi+4*ecx-4]
	mov ecx,edx
	clc
	.repeat
		mov eax,dword ptr [esi+4*ecx]
		sbb dword ptr [edi+4*ecx],eax
	.untilcxz
	mov ecx,x1
	.if CARRY?
		mov edx,edi
		mov ecx,edi
		sub ecx,x1
		shr ecx,2
		stc
		.repeat
			sbb dword ptr [edi],0
			lea edi,[edi-4]
			lea ecx,[ecx-1]
			jecxz @F
		.until !CARRY?
	@@:	
		.if CARRY?
			or [ebx][CALC_DESCRIPTOR.ErrFlags],OVERFLOW_FLAG
		.endif
		mov ecx,x1
	.endif
	mov edx,ecx
	mov eax,[ebx][CALC_DESCRIPTOR.int_length]
	shl eax,2
	add eax,edx
	.repeat
		add ecx,4
	.until dword ptr [ecx] || ecx>=eax
	sub ecx,x1
	shr ecx,2
	mov eax,[ebx][CALC_DESCRIPTOR.int_length]
	sub eax,ecx
	and dword ptr [edx],80000000h
	or [edx],eax
	ret
ureal_sub endp

uint_div proc uses esi edi ebx hCalc,x1,x2,Remn
LOCAL Signum,rSignum
LOCAL pqV	;   
LOCAL q_j	;      
LOCAL q_	;   
LOCAL j		;   
LOCAL d		;  
LOCAL pV	;  
LOCAL n		;   
LOCAL pU,psU	;  
LOCAL m		;   
LOCAL pQ	;  
assume ebx:ptr CALC_DESCRIPTOR
	mov ebx,hCalc
	cld
	mov eax,[ebx].msr2
	mov pqV,eax
	mov [ebx].ErrFlags,0
	.if !Remn	;     
		mov esi,[ebx].msr0
		mov Remn,esi
	.endif
	mov eax,Remn
	mov eax,[eax]
	mov rSignum,eax
	mov esi,x1
	mov edi,x2
	mov eax,[esi]
	mov Signum,eax
	mov ecx,[ebx].int_length
	and eax,7FFFFFFFh
	.if ZERO?	;   
		xor eax,eax
		mov edi,Remn
		rep stosd
		inc eax
		ret
	.endif
	mov edx,[edi]
	and edx,7FFFFFFFh
	.if ZERO?	;   
		or [ebx].ErrFlags,DIV_BY_ZERO
		xor eax,eax
		ret
	.endif
	mov m,eax
	mov n,edx
	.if eax<edx	;   
@@:
		mov edi,Remn
		rep movsd
		mov ecx,[ebx].int_length
		xor eax,eax
		mov edi,x1
		rep stosd
		inc eax
		ret
	.endif
	.if ZERO?	;   
		sub ecx,eax
		lea esi,[esi+4*ecx]
		lea edi,[edi+4*ecx]
		mov ecx,eax
		repe cmpsd
		mov esi,x1
		mov ecx,[ebx].int_length
		jc @B
		.if ZERO?	;   
			xor eax,eax
			mov edi,Remn
			rep stosd
			mov edx,eax
			inc eax
			invoke uild,ebx,esi
			mov eax,TRUE
			ret
		.endif
	.endif
	mov edi,Remn	; Remn  
	rep movsd
	lea ecx,[4*eax]
	sub edi,ecx
	mov pU,edi
	mov psU,edi
	mov esi,x2
	mov ecx,[ebx].int_length
	sub ecx,edx
	lea esi,[esi+4*ecx]
	mov edi,[ebx].msr1	; msr1  
	mov pV,edi
	mov ecx,edx
	rep movsd
	xor eax,eax
	mov edi,x1
	mov ecx,[ebx].int_length
	rep stosd
	mov edi,pV
	mov ecx,[edi]
	mov edx,1
	inc ecx
	.if !ZERO?	;  
		div ecx
	.else
		inc eax
	.endif
	mov d,eax
	.if eax>1	;HOPMAA
		mov edi,pU
		sub edi,4
		mov ecx,m
		mov ebx,d
		smulm
		.if !ZERO? || m==1
			mov [edi],edx
			mov pU,edi
			inc m
			mov psU,edi
		.endif
		mov edi,pV
		sub edi,4
		mov ecx,n
		smulm
	.endif
	mov esi,x1
	mov eax,m
	sub eax,n
	.if ZERO?
		inc eax
	.endif
	mov j,eax
	mov ebx,hCalc
	mov ecx,[ebx].int_length
	sub ecx,eax
	mov edi,x1
	lea edi,[edi+4*ecx]
	mov pQ,edi
	mov q_j,edi
	.repeat	;  
		mov edi,pU
		mov esi,pV
		xor edx,edx
		mov eax,[edi]
		mov ecx,[esi]
		div ecx
		mov ebx,eax
		mov eax,[edi+4]
		div ecx
		.if ebx
			sub edi,4
			mov dword ptr [edi],0
			mov pU,edi
			sub pQ,4
			mov eax,pQ
			mov dword ptr [eax],0
			mov q_j,eax
			mov eax,ebx
			inc j
		.endif
		mov q_,eax
		mov ecx,edx
;	@@:
;		.if !CARRY?
;			mul dword ptr [esi+4]
;			.if edx>ecx
;				dec q_
;				add ecx,[esi]
;				mov eax,q_
;				jnc @B
;			.elseif ZERO?
;				.if eax>[edi+8]
;					dec q_
;					add ecx,[esi]
;					mov eax,q_
;					jnc @B					
;				.endif
;			.endif
;		.endif
		.while TRUE	;
			mov edi,pV
			sub edi,4
			mov ecx,n
			mov ebx,pqV
			xor esi,esi
			.repeat
				mov eax,[edi+4*ecx]
				mul q_
				add eax,esi
				adc edx,0
				mov esi,edx
				mov dword ptr [ebx+4*ecx],eax
			.untilcxz
			mov dword ptr [ebx],edx
			mov ecx,n
			mov edi,ebx
			sub ebx,4
			inc ecx
			mov esi,pU
			repe cmpsd
			.break .if !CARRY?
			dec q_
		.endw
		mov edx,pU
		sub edx,4
		mov ecx,n
		inc ecx
		.repeat	;
			mov eax,dword ptr [ebx+4*ecx]
			sbb [edx+4*ecx],eax
		.untilcxz
		mov eax,q_
		mov edx,q_j
		mov [edx],eax
		add q_j,4
		add pU,4
		dec j
	.until ZERO?
	mov ebx,hCalc
	mov edi,pQ
	xor eax,eax
	repe scasd
	.if dword ptr [edi-4]
		sub edi,4
	.endif
	sub edi,x1
	shr edi,2
	mov ecx,[ebx].int_length
	sub ecx,edi
	mov edi,x1
	mov eax,Signum
	and eax,80000000h
	or eax,ecx
	mov [edi],eax
	mov ebx,hCalc
	mov edi,psU
	xor eax,eax
	mov ecx,m
	repe scasd
	.if !ZERO?
		inc ecx
		mov eax,rSignum
		and eax,80000000h
		or eax,ecx
	.endif
	mov edi,Remn
	mov [edi],eax
	invoke ShortDivUx,ebx,Remn,d
	mov eax,TRUE
	ret
assume ebx:nothing
uint_div endp
;   
uint_cmp proc uses esi edi ebx hCalc,x1,x2
	mov edi,x2
	mov esi,x1
	mov eax,[esi]
	mov edx,[edi]
	and eax,7FFFFFFFh
	and edx,7FFFFFFFh
	.if (eax==edx) && eax
		mov ebx,hCalc
		mov ecx,[ebx][CALC_DESCRIPTOR.int_length]
		sub ecx,eax
		lea edi,[edi+4*ecx]
		lea esi,[esi+4*ecx]
		mov ecx,eax
		repe cmpsd
	.endif
	ret
uint_cmp endp
;   
ureal_cmp proc uses esi edi ebx hCalc,x1,x2
	mov edi,x2
	mov esi,x1
	mov eax,[esi]
	mov edx,[edi]
	and eax,7FFFFFFFh
	and edx,7FFFFFFFh
	.if (eax==edx)
		mov ebx,hCalc
		mov ecx,[ebx][CALC_DESCRIPTOR.int_length]
		sub ecx,eax
		lea edi,[edi+4*ecx]
		lea esi,[esi+4*ecx]
		mov ecx,eax
		add ecx,[ebx][CALC_DESCRIPTOR.fract_length]
		repe cmpsd
	.endif
	ret
ureal_cmp endp
ShortUintPow proc uses edi esi ebx hCalc,x1,n
LOCAL m,cnt
	mov ebx,hCalc
	mov ecx,[ebx][CALC_DESCRIPTOR.int_length]
	xor eax,eax
	mov edi,x1
	lea edi,[edi+4*ecx-8]
	mov eax,[edi+4]
	mov m,eax
	mov cnt,1
	mov ecx,n
	xor ecx,ecx
	.repeat
		mul m
		inc ecx
	.until edx || ecx==n
	.if ecx==n
		div m
		mov [edi+4],eax
		ret
	.endif
	.if ecx>1
		div m
		mov esi,m
		mov m,eax
		mov eax,n
		div ecx
		mov n,eax
		mov ecx,edx
		mov eax,esi
		dec ecx
		je @F
		.if !SIGN?
			.repeat
				mul esi
			.untilcxz
		@@:
			mul m
			mov [edi+4],eax
			.if edx
				mov [edi],edx
				sub edi,4
				inc cnt
			.endif
		.else
			mov eax,m
			mov [edi+4],eax
		.endif
	.endif
	dec n
	mov ebx,m
	.if n>0 && m>1
		.repeat
			mov ecx,cnt
			smulm
			.if !ZERO?
				mov [edi],edx
				sub edi,4
				inc cnt
			.endif
			dec n
		.until ZERO?
	.endif
	mov eax,cnt
	mov edx,x1
	and dword ptr [edx],80000000h
	or [edx],eax
	ret
ShortUintPow endp
fmtitoax proc uses edi esi ebx hCalc,x1,Radix,MaxNum
LOCAL Nums,Trim
	mov ebx,hCalc
	mov edi,x1
	mov eax,[edi]
	and eax,7FFFFFFFh
	.if eax>2	;      
		mov ecx,[ebx][CALC_DESCRIPTOR.int_length]
		sub ecx,eax
		mov edx,[edi+4*ecx]	;Ш    
		dec eax
		shl eax,5	; eax      ר    
		xor ecx,ecx
		bsr ecx,edx
		inc ecx		; ecx       
		add eax,ecx	; eax     Ѩ  
		mov Nums,eax
		fld1	;         Radix
		fld1	; ٨  
		fild Radix
		fyl2x
		fdivp st(1),st(0)
		fild Nums
		fmulp st(1),st(0)
		frndint
		fistp Nums	; Nums        Radix
		mov eax,Nums
		.if eax<=MaxNum	;      
			inc [ebx][CALC_DESCRIPTOR.ascii_buff]	;   
			dec [ebx][CALC_DESCRIPTOR.size_abuff]
			invoke itoaX,hCalc,x1,Radix
			dec [ebx][CALC_DESCRIPTOR.ascii_buff]
			inc [ebx][CALC_DESCRIPTOR.size_abuff]
			mov eax,[ebx][CALC_DESCRIPTOR.ascii_buff]
			mov cl,[eax+1]
			mov [eax],cl
			.if cl=='-'
				mov cl,[eax+2]
				mov [eax+1],cl
				mov cl,[ebx][CALC_DESCRIPTOR.DecimalSeparator]
				mov [eax+2],cl
				lea eax,[eax+edx+2]
				dec edx
			.else
				mov cl,[ebx][CALC_DESCRIPTOR.DecimalSeparator]
				mov [eax+1],cl
				lea eax,[eax+edx+2]
			.endif
			.while byte ptr [eax-1]=='0'
				dec eax
			.endw
			mov cl,[ebx][CALC_DESCRIPTOR.DecimalSeparator]
			.if byte ptr [eax-1]==cl
				inc eax
			.endif
			mov word ptr [eax],'+e'
			add eax,2
			invoke _ultoa,edx,eax,Radix
			ret
		.endif
		mov esi,x1
		mov edi,[ebx][CALC_DESCRIPTOR.msr6]
		mov ecx,[ebx][CALC_DESCRIPTOR.int_length]
		add ecx,[ebx][CALC_DESCRIPTOR.fract_length]
		rep movsd	;  X1-->msr6
		sub eax,MaxNum	; eax        
		mov Trim,eax	;     ( Radix)
		mov edi,[ebx][CALC_DESCRIPTOR.msr7]
		mov esi,edi
		mov dword ptr [edi],1
		mov ecx,[ebx][CALC_DESCRIPTOR.int_length]
		dec ecx
		add edi,4
		xor eax,eax
		rep stosd
		mov eax,Radix
		mov [edi-4],eax
		invoke ShortUintPow,ebx,esi,Trim
		invoke uint_div,ebx,[ebx][CALC_DESCRIPTOR.msr6],esi,NULL
;		invoke rsuidiv_bypow,hCalc,[ebx][CALC_DESCRIPTOR.msr6],Radix,Trim
		inc [ebx][CALC_DESCRIPTOR.ascii_buff]	;   
		dec [ebx][CALC_DESCRIPTOR.size_abuff]
		invoke itoaX,hCalc,[ebx][CALC_DESCRIPTOR.msr6],Radix
		dec [ebx][CALC_DESCRIPTOR.ascii_buff]
		inc [ebx][CALC_DESCRIPTOR.size_abuff]
		mov eax,[ebx][CALC_DESCRIPTOR.ascii_buff]
		mov cl,[eax+1]
		mov [eax],cl
		.if cl=='-'
			mov cl,[eax+2]
			mov [eax+1],cl
			mov cl,[ebx][CALC_DESCRIPTOR.DecimalSeparator]
			mov [eax+2],cl
			lea eax,[eax+edx+2]
			dec edx
		.else
			mov cl,[ebx][CALC_DESCRIPTOR.DecimalSeparator]
			mov [eax+1],cl
			lea eax,[eax+edx+2]
		.endif
		.while byte ptr [eax-1]=='0'
			dec eax
		.endw
		mov cl,[ebx][CALC_DESCRIPTOR.DecimalSeparator]
		.if byte ptr [eax-1]==cl
			inc eax
		.endif
		add edx,Trim
		mov word ptr [eax],'+e'
		add eax,2
		invoke _ultoa,edx,eax,Radix
	.else
		invoke itoaX,hCalc,x1,Radix
	.endif
	ret
fmtitoax endp
rsuidiv_bypow proc uses edi esi ebx hCalc,x1,dwx2,_pow
LOCAL cnt1,cnt2,diver
	mov edi,x1
	.if _pow && (dword ptr [edi]&7FFFFFFFh)
		.if dwx2
			mov ebx,hCalc
			mov eax,dwx2
			xor edx,edx
			xor ecx,ecx
			.repeat
				mul dwx2
				inc ecx
			.until edx || ecx==_pow
			.if edx
				div dwx2
				dec ecx
			.endif
			inc ecx
			mov diver,eax
			mov eax,_pow
			xor edx,edx
			div ecx
			mov cnt1,eax
			mov cnt2,edx
			.while cnt1
				mov ecx,[edi]
				.break .if !(dword ptr [edi]&7FFFFFFFh)
				invoke ShortDivUx,ebx,edi,diver
				dec cnt1
			.endw
			.while cnt2
				mov ecx,[edi]
				.break .if !(dword ptr [edi]&7FFFFFFFh)
				invoke ShortDivUx,ebx,edi,dwx2
				dec cnt2
			.endw
		.else
			mov eax,x1
			and dword ptr [eax],80000000h
		.endif
	.endif
	ret
rsuidiv_bypow endp
;msr0,msr1,msr6,msr7
fmtrtoa proc uses esi edi ebx hCalc,x1,Radix,MaxNum
LOCAL iNums,Trim
	mov ebx,hCalc
	.if [ebx][CALC_DESCRIPTOR.fract_length]
		mov edi,x1
		mov eax,[edi]
		and eax,7FFFFFFFh
		mov iNums,0
		.if !ZERO?
			mov ecx,[ebx][CALC_DESCRIPTOR.int_length]
			sub ecx,eax
			mov edx,[edi+4*ecx]
			dec eax
			shl eax,5
			bsr ecx,edx
			inc ecx
			add eax,ecx
			mov iNums,eax
			fld1
			fld1
			fild Radix
			fyl2x
			fdivp st(1),st(0)
			fild iNums
			fmulp st(1),st(0)
			frndint
			fistp iNums
			mov eax,iNums
			mov edx,MaxNum
			.if eax<edx
				sub edx,eax
				mov Trim,edx
				mov eax,Radix
				xor edx,edx
				invoke uild,hCalc,[ebx][CALC_DESCRIPTOR.msr7]
				invoke ShortUintPow,hCalc,[ebx][CALC_DESCRIPTOR.msr7],Trim
				mov esi,x1
				mov edi,[ebx][CALC_DESCRIPTOR.msr6]
				mov ecx,[ebx][CALC_DESCRIPTOR.int_length]
				add ecx,[ebx][CALC_DESCRIPTOR.fract_length]
				rep movsd
				invoke rmul,hCalc,[ebx][CALC_DESCRIPTOR.msr6],[ebx][CALC_DESCRIPTOR.msr7]
				inc [ebx][CALC_DESCRIPTOR.ascii_buff]
				dec [ebx][CALC_DESCRIPTOR.size_abuff]
				invoke itoaX,hCalc,[ebx][CALC_DESCRIPTOR.msr6],Radix
			@@:
				dec [ebx][CALC_DESCRIPTOR.ascii_buff]
				inc [ebx][CALC_DESCRIPTOR.size_abuff]
				mov eax,[ebx][CALC_DESCRIPTOR.ascii_buff]
				mov cl,[eax+1]
				mov [eax],cl
				.if cl=='-'
					mov cl,[eax+2]
					mov [eax+1],cl
					mov cl,[ebx][CALC_DESCRIPTOR.DecimalSeparator]
					mov [eax+2],cl
					.if edx>MaxNum
						inc iNums
					.endif
				.else
					mov cl,[ebx][CALC_DESCRIPTOR.DecimalSeparator]
					mov [eax+1],cl
					inc edx
					.if edx>MaxNum
						inc iNums
					.endif
					dec edx
				.endif
				lea eax,[eax+edx+2]
				.while byte ptr [eax-1]=='0'
					dec eax
				.endw
				.if byte ptr [eax-1]==','
					inc eax
				.endif
				dec iNums
				.if !ZERO?
					mov byte ptr [eax],'e'
					inc eax
					invoke _ultoa,iNums,eax,Radix
				.endif
;			.elseif ZERO?
;				inc [ebx][CALC_DESCRIPTOR.ascii_buff]
;				dec [ebx][CALC_DESCRIPTOR.size_abuff]
;				invoke itoaX,hCalc,x1,Radix
;				jmp @B
			.else
				invoke fmtitoax,ebx,x1,Radix,MaxNum
			.endif
		.else
			mov ecx,[ebx][CALC_DESCRIPTOR.int_length]
			lea edi,[edi+4*ecx]
			mov esi,edi
			mov ecx,[ebx][CALC_DESCRIPTOR.fract_length]
			repe scasd
			.if ZERO?
				mov eax,[ebx][CALC_DESCRIPTOR.ascii_buff]
				mov dword ptr [eax],'0'
			.else
				mov edx,[edi-4]
				bsr ecx,edx
				inc ecx
				sub edi,esi
				lea edx,[8*edi]
				sub edx,ecx
				mov iNums,edx
				fld1
				fld1
				fild Radix
				fyl2x
				fdivp st(1),st(0)
				fild iNums
				fmulp st(1),st(0)
				frndint
				fistp iNums
				mov eax,MaxNum
				add eax,iNums
				mov Trim,eax
				mov eax,Radix
				xor edx,edx
				invoke uild,hCalc,[ebx][CALC_DESCRIPTOR.msr7]
				invoke ShortUintPow,hCalc,[ebx][CALC_DESCRIPTOR.msr7],Trim
				mov esi,x1
				mov edi,[ebx][CALC_DESCRIPTOR.msr6]
				mov ecx,[ebx][CALC_DESCRIPTOR.int_length]
				add ecx,[ebx][CALC_DESCRIPTOR.fract_length]
				rep movsd
				invoke rmul,hCalc,[ebx][CALC_DESCRIPTOR.msr6],[ebx][CALC_DESCRIPTOR.msr7]
				inc [ebx][CALC_DESCRIPTOR.ascii_buff]
				dec [ebx][CALC_DESCRIPTOR.size_abuff]
				invoke itoaX,hCalc,[ebx][CALC_DESCRIPTOR.msr6],Radix
				dec [ebx][CALC_DESCRIPTOR.ascii_buff]
				inc [ebx][CALC_DESCRIPTOR.size_abuff]
				mov eax,[ebx][CALC_DESCRIPTOR.ascii_buff]
				mov cl,[eax+1]
				mov [eax],cl
				.if cl=='-'
					mov cl,[eax+2]
					mov [eax+1],cl
					mov cl,[ebx][CALC_DESCRIPTOR.DecimalSeparator]
					mov [eax+2],cl
					.if edx>MaxNum
						dec iNums
					.endif
				.else
					mov cl,[ebx][CALC_DESCRIPTOR.DecimalSeparator]
					mov [eax+1],cl
					inc edx
					.if edx>MaxNum
						dec iNums
					.endif
					dec edx
				.endif
				lea eax,[eax+edx+2]
				.while byte ptr [eax-1]=='0'
					dec eax
				.endw
				mov word ptr [eax],'-e'
				add eax,2
				inc iNums
				invoke _ultoa,iNums,eax,Radix
			.endif
		.endif
	.else
		invoke fmtitoax,ebx,x1,Radix,MaxNum
	.endif
	ret
fmtrtoa endp
fmtator proc uses edi esi ebx hCalc,x1,Radix
LOCAL Divid
	mov Divid,FALSE
	invoke atorX,hCalc,x1,Radix
	mov ebx,hCalc
	mov edi,[ebx][CALC_DESCRIPTOR.ascii_buff]
	mov eax,'e'
	.while byte ptr [edi] && al!=byte ptr [edi]
		inc edi
	.endw
	.if al==byte ptr [edi]
		inc edi
		.if byte ptr [edi]=='-'
			mov Divid,TRUE
			inc edi
		.endif
		movzx ebx,byte ptr[edi]
		mov ecx,Radix
		xor eax,eax
		.repeat
			.if ebx>='A' && ebx<='Z'
				sub ebx,7
			.endif
			sub ebx,'0'
			mul ecx
			add eax,ebx
			inc edi
			movzx ebx,byte ptr [edi]
		.until !ebx
		mov edx,eax
		xor eax,eax
		mov ebx,hCalc
		mov edi,[ebx][CALC_DESCRIPTOR.msr7]
		mov dword ptr [edi],1
		add edi,4
		mov ecx,[ebx][CALC_DESCRIPTOR.int_length]
		dec ecx
		add ecx,[ebx][CALC_DESCRIPTOR.fract_length]
		rep stosd
		mov edi,[ebx][CALC_DESCRIPTOR.msr7]
		mov ecx,[ebx][CALC_DESCRIPTOR.int_length]
		lea edi,[edi+4*ecx-4]
		mov eax,Radix
		mov [edi],eax
		invoke ShortUintPow,ebx,[ebx][CALC_DESCRIPTOR.msr7],edx
		.if [ebx][CALC_DESCRIPTOR.fract_length]
			.if Divid
				invoke rdiv,ebx,x1,[ebx][CALC_DESCRIPTOR.msr7]
			.else
				invoke rmul,ebx,x1,[ebx][CALC_DESCRIPTOR.msr7]
			.endif
		.else
			.if Divid
				invoke uint_div,ebx,x1,[ebx][CALC_DESCRIPTOR.msr7],NULL
			.else
				invoke uint_mul,ebx,x1,[ebx][CALC_DESCRIPTOR.msr7]
			.endif
		.endif
	.endif
	ret
fmtator endp
itoa_sub proc Radix,Sign ;7C92F267
   cmp Sign, 0
   jnz Chs
Begin:
   push esi
   mov esi, ecx
NextChar:
   xor edx, edx
   div Radix
   cmp edx, 9
   ja Letter
   add dl, 30h
Cont:
   mov [ecx], dl
   inc ecx
   test eax, eax
   ja NextChar
   mov byte ptr [ecx], 0
   dec ecx
   .repeat
      mov dl, [esi]
      mov al, [ecx]
      mov [ecx], dl
      dec ecx
      mov [esi], al
      inc esi
   .until esi>=ecx
   pop esi
   ret

Chs:   
   mov byte ptr [ecx], '-'    ;7C94F71B
   inc ecx 
   neg eax 
   jmp Begin                  ;7C94F721

Letter:                       ;7C94F726
   add dl, 37h 
   jmp Cont                   ;7C94F729

itoa_sub endp   ;7C92F2A5
_ultoa proc C Val,pBuff,Radix ;7C96FEBE
   mov ecx, pBuff
   mov eax, Val
   invoke itoa_sub,Radix,0
   mov eax, pBuff
   ret
_ultoa endp                    ;7C96FED7
Unfactorial proc uses edi esi ebx hCalc,x1,Remn,maxN
	mov ebx,hCalc
	mov edx,maxN
	mov edi,x1
	.if edx
		invoke Factorial,ebx,[ebx][CALC_DESCRIPTOR.msr7],edx
	.elseif (dword ptr [edi])&7FFFFFFFh
		xor edx,edx
		mov eax,1
		invoke uild,ebx,[ebx][CALC_DESCRIPTOR.msr7]	;  
		mov maxN,0
		.repeat
			inc maxN
			invoke ShortMulUx,ebx,[ebx][CALC_DESCRIPTOR.msr7],maxN
			.break .if eax
			invoke uint_cmp,ebx,edi,[ebx][CALC_DESCRIPTOR.msr7]
		.until CARRY?
		.if eax
			mov edi,[ebx][CALC_DESCRIPTOR.msr7]
			add edi,4
			mov esi,maxN
			mov ecx,[ebx][CALC_DESCRIPTOR.int_length]
			dec ecx
			sdivm
		.else
			invoke ShortDivUx,ebx,[ebx][CALC_DESCRIPTOR.msr7],maxN
		.endif
		dec maxN
	.else
		xor eax,eax
		xor edx,edx
		ret
	.endif
	mov edi,x1
	invoke uint_div,ebx,edi,[ebx][CALC_DESCRIPTOR.msr7],Remn
	mov eax,maxN
	mov edx,[ebx][CALC_DESCRIPTOR.int_length]
	mov edx,[edi+4*edx-4]
	ret
Unfactorial endp
Factorial proc uses edi esi ebx hCalc,x1,n
LOCAL RightBorder,sv_Esp
	mov sv_Esp,esp
	mov ebx,hCalc
	mov edi,x1
	.if !edi
		mov edi,[ebx][CALC_DESCRIPTOR.msr0]
		mov x1,edi
	.endif
	mov ecx,[ebx][CALC_DESCRIPTOR.int_length]
	xor eax,eax
	mov esi,n
	.if !esi
		mov esi,[edi+4*ecx-4]
		mov n,esi
	.endif
	rep stosd
	sub edi,4
	.if esi<10000h && esi>4
		.if esi&1
			mov eax,esi
			lea ecx,[esi-1]
			mul ecx
			mov [edi],eax
			sub esi,2
		.else
			mov [edi],esi
			dec esi
		.endif
		mov n,esi
		mov RightBorder,1
		sub edi,4
		.repeat
			mov esi,n
			dec n
			imul esi,n
			.break .if !esi
			mov ecx,RightBorder
			xor ebx,ebx
			.repeat
				mov eax,dword ptr [edi+4*ecx]
				mul esi
				add eax,ebx
				adc edx,0
				mov ebx,edx
				mov dword ptr [edi+4*ecx],eax
			.untilcxz
			.if !ZERO?
				mov dword ptr [edi],edx
				mov eax,RightBorder
				.if dword ptr [edi+4*eax]
					inc RightBorder
				.endif
				sub edi,4
			.endif
			dec n
		.until SIGN?
		.while !(dword ptr [edi])
			add edi,4
		.endw
;		.if !edx
;			add edi,4
;		.endif
	.elseif esi>1
		mov [edi],esi
		dec esi
		mov RightBorder,1
		sub edi,4
		.repeat
			mov ecx,RightBorder
			xor ebx,ebx
			.repeat
				mov eax,dword ptr [edi+4*ecx]
				mul esi
				add eax,ebx
				adc edx,0
				mov ebx,edx
				mov dword ptr [edi+4*ecx],eax
			.untilcxz
			.if !ZERO?
				mov dword ptr [edi],edx
				mov eax,RightBorder
				.if dword ptr [edi+4*eax]
					inc RightBorder
				.endif
				sub edi,4
			.endif
			dec esi
		.until ZERO?
		.while !(dword ptr [edi])
			add edi,4
		.endw
;		.if !edx
;			add edi,4
;		.endif
	.else
		mov dword ptr [edi],1
	.endif
	mov esi,x1
	mov ebx,hCalc
	mov ecx,[ebx][CALC_DESCRIPTOR.int_length]
	mov eax,edi
	sub eax,esi
	shr eax,2
	sub ecx,eax
	mov [esi],ecx
	mov esp,sv_Esp
	ret
Factorial endp
buffuild proc uses esi edi ebx hCalc,x1,pBuff,szBuff
	mov ebx,hCalc
	mov edi,x1
	mov ecx,[ebx][CALC_DESCRIPTOR.int_length]
	xor eax,eax
	rep stosd
	mov ecx,[ebx][CALC_DESCRIPTOR.int_length]
	dec ecx
	mov edx,szBuff
	shr edx,2
	.if edx>ecx || !edx
		mov edx,ecx
	.endif
	mov edi,pBuff
	xor eax,eax
	mov ecx,edx
	repe scasd
	inc ecx
	sub edi,4
	mov esi,edi
	mov edi,x1
	mov [edi],ecx
	mov edx,[ebx][CALC_DESCRIPTOR.int_length]
	sub edx,ecx
	lea edi,[edi+4*edx]
	rep movsd
	ret
buffuild endp
;   x1==x1/x2
rdiv proc uses esi edi ebx hCalc,x1,x2
LOCAL Signum,rSignum,Remn
LOCAL pqV	;   
LOCAL q_j	;      
LOCAL q_	;   
LOCAL j		;   
LOCAL d		;  
LOCAL pV	;  
LOCAL n		;   
LOCAL pU,psU	;  
LOCAL m		;   
LOCAL pQ	;  
LOCAL TotalLength ;      
assume ebx:ptr CALC_DESCRIPTOR
	mov ebx,hCalc
	mov eax,[ebx].int_length
	add eax,[ebx].fract_length
	mov TotalLength,eax
	cld
	mov eax,[ebx].msr2
	mov pqV,eax
	mov [ebx].ErrFlags,0
	mov esi,[ebx].msr0
	mov Remn,esi
	mov esi,x1
	mov eax,[esi]
	mov Signum,eax
	and eax,7FFFFFFFh
	.if ZERO?	;     
		mov edi,[ebx].int_length
		lea edi,[esi+4*edi]
		mov ecx,[ebx].fract_length
		repe scasd
		.if ZERO?	 ;   
			inc eax
			ret
		.endif
		lea eax,[ecx+1]
	.else
		add eax,[ebx].fract_length
	.endif
	mov edi,x2
	mov edx,[edi]
	and edx,7FFFFFFFh
	.if ZERO?	;     
		push eax
		mov ecx,[ebx].int_length
		lea edi,[edi+4*ecx]
		xor eax,eax
		mov ecx,[ebx].fract_length
		repe scasd
		pop eax
		.if ZERO?	 ;   
			or [ebx].ErrFlags,DIV_BY_ZERO
			xor eax,eax
			ret
		.endif
		lea edx,[ecx+1]
	.else
		add edx,[ebx].fract_length
	.endif
	add eax,[ebx].fract_length
	mov m,eax
	mov n,edx
	mov ecx,TotalLength
	.if eax<edx	;   
@@:
		xor eax,eax
		mov edi,x1
		rep stosd
		inc eax
		ret
	.endif
	.if ZERO?	;   
		sub ecx,eax
		lea esi,[esi+4*ecx]
		add ecx,[ebx].fract_length
		lea edi,[edi+4*ecx]
		mov ecx,eax
		sub ecx,[ebx].fract_length
		repe cmpsd
		.if ZERO?
			mov ecx,[ebx].fract_length
			xor eax,eax
			repe scasd
			jnz @B
		.endif
		mov esi,x1
		mov ecx,TotalLength
		jc @B
		.if ZERO?	;   
			xor eax,eax
			mov edi,x1
			rep stosd
			mov dword ptr [edi-4],1
			mov eax,TRUE
			ret
		.endif
	.endif
	mov edi,Remn	; Remn  
	rep movsd
	mov ecx,[ebx].fract_length
	xor eax,eax
	rep stosd
	mov ecx,m
	shl ecx,2
	sub edi,ecx
	mov pU,edi
	mov psU,edi
	mov esi,x2
	mov ecx,TotalLength
	sub ecx,edx
	lea esi,[esi+4*ecx]
	mov edi,[ebx].msr3	; msr3  
	mov pV,edi
	mov ecx,edx
	rep movsd
	xor eax,eax
	mov edi,x1
	mov ecx,TotalLength
	rep stosd
	mov edi,pV
	mov ecx,[edi]
	mov edx,1
	inc ecx
	.if !ZERO?	;  
		div ecx
	.else
		inc eax
	.endif
	mov d,eax
	.if eax>1	;HOPMAA
		mov edi,pU
		sub edi,4
		mov ecx,m
		mov ebx,d
		smulm
		.if !ZERO? || m==1
			mov [edi],edx
			mov pU,edi
			mov psU,edi
			inc m
		.endif
		mov edi,pV
		sub edi,4
		mov ecx,n
		smulm
	.endif
	mov esi,x1
	mov eax,m
	mov ebx,hCalc
	sub eax,n
	.if ZERO?
		inc eax
	.endif
	mov j,eax
	inc eax
	.if eax>=TotalLength	; 
		or [ebx].ErrFlags,OVERFLOW_FLAG
		ret
	.endif
	mov edi,x1
	mov ecx,TotalLength
	sub ecx,j
	lea edi,[edi+4*ecx]
	mov pQ,edi
	mov q_j,edi
	.repeat	;  
		mov edi,pU
		mov esi,pV
		xor edx,edx
		mov eax,[edi]
		mov ecx,[esi]
		div ecx
		mov ebx,eax
		mov eax,[edi+4]
		div ecx
		.if ebx
			sub edi,4
			mov dword ptr [edi],0
			mov pU,edi
			sub pQ,4
			mov eax,pQ
			mov dword ptr [eax],0
			mov q_j,eax
			mov eax,ebx
			inc j
		.endif
		mov q_,eax
		mov ecx,edx
		.while TRUE	;
			mov edi,pV
			sub edi,4
			mov ecx,n
			mov ebx,pqV
			xor esi,esi
			.repeat
				mov eax,[edi+4*ecx]
				mul q_
				add eax,esi
				adc edx,0
				mov esi,edx
				mov dword ptr [ebx+4*ecx],eax
			.untilcxz
			mov dword ptr [ebx],edx
			mov ecx,n
			mov edi,ebx
			sub ebx,4
			inc ecx
			mov esi,pU
			repe cmpsd
			.break .if !CARRY?
			dec q_
		.endw
		mov edx,pU
		sub edx,4
		mov ecx,n
		inc ecx
		.repeat	;
			mov eax,dword ptr [ebx+4*ecx]
			sbb [edx+4*ecx],eax
		.untilcxz
		mov eax,q_
		mov edx,q_j
		mov [edx],eax
		add q_j,4
		add pU,4
		dec j
	.until ZERO?
	mov ebx,hCalc
	mov ecx,q_j
	mov esi,pQ
	.while !(dword ptr [esi])
		add esi,4
	.endw
	sub ecx,esi
	shr ecx,2
	mov edi,x1
	sub ecx,[ebx].fract_length
	.if SIGN?
		;add ecx,[ebx].fract_length
		mov dword ptr [edi],0
	.else
		mov [edi],ecx
		;add ecx,[ebx].fract_length
	.endif
;	mov eax,TotalLength
;	sub eax,ecx
;	shl eax,2
;	add edi,eax
;	rep movsd
	mov eax,Signum
	mov esi,x2
	mov esi,[esi]
	xor eax,esi
	and eax,80000000h
	mov edi,x1
	or [edi],eax
	mov eax,TRUE
	ret
assume ebx:nothing	
rdiv endp
;   x1==x1*x2
;msr0,msr1
rmul proc uses esi edi ebx hCalc,x1,x2
LOCAL m,n,signum,result,mprs,svEsp
assume ebx:ptr CALC_DESCRIPTOR
	mov ebx,hCalc
	mov ecx,[ebx][CALC_DESCRIPTOR.fract_length]
	mov edx,[ebx][CALC_DESCRIPTOR.int_length]
	add [ebx][CALC_DESCRIPTOR.int_length],ecx
	mov esi,x1
	mov eax,[esi]
	and eax,7FFFFFFFh
	.if ZERO?	;      
		lea edi,[esi+4*edx]
		mov ecx,[ebx].fract_length
		xor eax,eax
		repe scasd
		.if ZERO?	 ;    
			inc eax
			mov ebx,hCalc
			mov ecx,[ebx][CALC_DESCRIPTOR.fract_length]
			sub [ebx][CALC_DESCRIPTOR.int_length],ecx
			mov edx,x2
			mov eax,[edx]
			and dword ptr [edx],80000000h
			and eax,7FFFFFFFh
			sub eax,ecx
			.if SIGN?
				xor eax,eax
			.endif
			or [edx],eax
			xor eax,eax
			ret
		.endif
		lea eax,[ecx+1]
	.else
		add eax,[ebx].fract_length
	.endif
	and dword ptr [esi],80000000h
	or [esi],eax
	mov esi,x2
	mov eax,[esi]
	and eax,7FFFFFFFh
	.if ZERO?	;      
		lea edi,[esi+4*edx]
		mov ecx,[ebx].fract_length
		xor eax,eax
		repe scasd
		.if ZERO?	 ;    
			inc eax
			jmp movz
		.endif
		lea eax,[ecx+1]
	.else
		add eax,[ebx].fract_length
	.endif
	and dword ptr [esi],80000000h
	or [esi],eax
	mov [ebx][CALC_DESCRIPTOR.ErrFlags],0
	mov ecx,[ebx][CALC_DESCRIPTOR.int_length]
	mov edi,[ebx][CALC_DESCRIPTOR.msr0]
	shl ecx,1
	xor eax,eax	;    
	rep stosd
	sub edi,4
	mov result,edi
	mov edi,x1
	mov eax,[edi]
	mov esi,x2
	mov edx,[esi]
	mov ecx,edx
	xor ecx,eax
	and ecx,80000000h
	mov signum,ecx
	and eax,7FFFFFFFh
	jz Exit
	and edx,7FFFFFFFh
	jz movz
	mov m,eax
	mov n,edx
	mov ecx,[ebx][CALC_DESCRIPTOR.int_length]
	lea edx,[esi+4*ecx-4]
	mov mprs,edx
	sub ecx,eax
	lea edi,[edi+4*ecx-4]
	mov ebx,result
	shl eax,2
	sub ebx,eax
assume ebx:nothing
	mulm m,n,mprs,svEsp	; 
assume ebx:ptr CALC_DESCRIPTOR
	mov edx,result
	add edx,4
	sub edx,ebx
	shr edx,2
	mov edi,x1
	mov ebx,hCalc
	mov ecx,[ebx][CALC_DESCRIPTOR.int_length]
	xor eax,eax
	rep stosd
	std
	sub edi,4
	mov esi,result
	mov ecx,[ebx][CALC_DESCRIPTOR.fract_length]
	shl ecx,2
	sub esi,ecx
	shr ecx,2
	sub edx,ecx
	mov ecx,edx
	mov eax,[ebx][CALC_DESCRIPTOR.int_length]
	.if edx<eax
		mov eax,edx
	.else
		or [ebx][CALC_DESCRIPTOR.ErrFlags],OVERFLOW_FLAG
		dec eax
		mov ecx,eax
	.endif
	rep movsd
	cld
	sub edx,[ebx][CALC_DESCRIPTOR.fract_length]
	.if CARRY?
		xor edx,edx
	.endif
	sub eax,[ebx][CALC_DESCRIPTOR.fract_length]
	.if CARRY?
		xor eax,eax
	.endif
	or edx,signum
	or eax,signum
	mov edi,x1
	mov [edi],eax
	mov edi,[ebx][CALC_DESCRIPTOR.msr0]
	mov [edi],edx
Exit:
	mov ebx,hCalc
	mov ecx,[ebx][CALC_DESCRIPTOR.fract_length]
	sub [ebx][CALC_DESCRIPTOR.int_length],ecx
	mov edx,x2
	mov eax,[edx]
	and dword ptr [edx],80000000h
	and eax,7FFFFFFFh
	sub eax,ecx
	.if SIGN?
		xor eax,eax
	.endif
	or [edx],eax
	mov eax,1
	ret
movz:
	mov edi,x1
	mov ecx,[ebx][CALC_DESCRIPTOR.int_length]
	xor eax,eax
	rep stosd
	mov ebx,hCalc
	mov ecx,[ebx][CALC_DESCRIPTOR.fract_length]
	sub [ebx][CALC_DESCRIPTOR.int_length],ecx
	mov edx,x2
	mov eax,[edx]
	and dword ptr [edx],80000000h
	and eax,7FFFFFFFh
	sub eax,ecx
	.if SIGN?
		xor eax,eax
	.endif
	or [edx],eax
	xor eax,eax
	ret
assume ebx:nothing
rmul endp
;   x1==x1+x2
radd proc uses esi edi ebx hCalc,x1,x2
	mov eax,x1
	mov eax,[eax]
	mov edx,x2
	mov edx,[edx]
	mov ecx,eax
	xor ecx,edx
	.if !SIGN?	;EC  
		invoke ureal_add,hCalc,x1,x2
	.else
		.if eax&80000000h	;EC  x1  
			invoke ureal_cmp,hCalc,x2,x1
			.if CARRY?	; x2<x1
				invoke ureal_sub,hCalc,x1,x2
				mov eax,x1
				or dword ptr [eax],80000000h
			.elseif ZERO?
				mov edi,x1
				xor eax,eax
				mov ecx,[ebx][CALC_DESCRIPTOR.int_length]
				add ecx,[ebx][CALC_DESCRIPTOR.fract_length]
				rep stosd
				ret
			.else
				mov ebx,hCalc
				mov ecx,[ebx][CALC_DESCRIPTOR.int_length]
				add ecx,[ebx][CALC_DESCRIPTOR.fract_length]
				mov esi,x1
				mov edi,[ebx][CALC_DESCRIPTOR.msr0]
				mov edx,ecx
				rep movsd
				mov ecx,edx
				mov esi,x2
				mov edi,x1
				rep movsd
				invoke ureal_sub,ebx,x1,[ebx][CALC_DESCRIPTOR.msr0]
				mov eax,x1
				and dword ptr [eax],7FFFFFFFh
			.endif
		.else
			invoke ureal_cmp,hCalc,x1,x2
			.if CARRY?
				mov ebx,hCalc
				mov ecx,[ebx][CALC_DESCRIPTOR.int_length]
				add ecx,[ebx][CALC_DESCRIPTOR.fract_length]
				mov esi,x1
				mov edi,[ebx][CALC_DESCRIPTOR.msr0]
				mov edx,ecx
				rep movsd
				mov ecx,edx
				mov esi,x2
				mov edi,x1
				rep movsd
				invoke ureal_sub,ebx,x1,[ebx][CALC_DESCRIPTOR.msr0]
				mov eax,x1
				or dword ptr [eax],80000000h
			.elseif ZERO?
				mov edi,x1
				xor eax,eax
				mov ecx,[ebx][CALC_DESCRIPTOR.int_length]
				add ecx,[ebx][CALC_DESCRIPTOR.fract_length]
				rep stosd
				ret
			.else
				invoke ureal_sub,hCalc,x1,x2
			.endif
		.endif
	.endif
	mov eax,TRUE
	ret
radd endp
;   x1==x1-x2
rsub proc hCalc,x1,x2
	mov eax,x1
	xor dword ptr [eax],80000000h
	invoke radd,hCalc,x1,x2
	.if eax
		mov eax,x1
		xor dword ptr [eax],80000000h
	.endif
	ret
rsub endp
int_div proc uses edi esi ebx hCalc,x1,x2,Remn
	invoke uint_div,hCalc,x1,x2,Remn
	mov ebx,hCalc
	mov esi,x1
	mov edi,x2
	mov eax,[esi]
	mov edx,[edi]
	mov ecx,Remn
	.if !ecx
		mov ecx,[ebx][CALC_DESCRIPTOR.msr0]
	.endif
	xor edx,eax
	.if !SIGN?	;  
		and dword ptr [esi],7FFFFFFFh
		or eax,eax
		.if SIGN?
			or dword ptr [ecx],80000000h
		.else
			and dword ptr [ecx],7FFFFFFFh
		.endif
	.else	;  
		or dword ptr [esi],80000000h
		mov edx,ecx
		mov esi,ecx
		mov edi,[ebx][CALC_DESCRIPTOR.msr2]
		mov ecx,[ebx][CALC_DESCRIPTOR.int_length]
		rep movsd
		mov esi,x2
		mov edi,edx
		mov ecx,[ebx][CALC_DESCRIPTOR.int_length]
		rep movsd
		mov esi,eax
		mov edi,edx
		invoke uint_sub,ebx,edx,[ebx][CALC_DESCRIPTOR.msr2]
		or esi,esi
		.if SIGN?	;    
			and dword ptr [edi],7FFFFFFFh
		.else
			or dword ptr [edi],80000000h
		.endif
	.endif
	ret
int_div endp
;   x1==x1+x2
int_add proc uses esi edi ebx hCalc,x1,x2
	mov eax,x1
	mov eax,[eax]
	mov edx,x2
	mov edx,[edx]
	mov ecx,eax
	xor ecx,edx
	.if !SIGN?	;EC  
		invoke uint_add,hCalc,x1,x2
	.else
		.if eax&80000000h	;  x1  
			invoke uint_cmp,hCalc,x2,x1
			.if CARRY?	; x2<x1
				invoke uint_sub,hCalc,x1,x2
				mov eax,x1
				or dword ptr [eax],80000000h
			.elseif ZERO?
				mov edi,x1
				xor eax,eax
				mov ecx,[ebx][CALC_DESCRIPTOR.int_length]
				rep stosd
				ret
			.else
				mov ebx,hCalc
				mov ecx,[ebx][CALC_DESCRIPTOR.int_length]
				mov esi,x1
				mov edi,[ebx][CALC_DESCRIPTOR.msr0]
				mov edx,ecx
				rep movsd
				mov ecx,edx
				mov esi,x2
				mov edi,x1
				rep movsd
				invoke uint_sub,ebx,x1,[ebx][CALC_DESCRIPTOR.msr0]
				mov eax,x1
				and dword ptr [eax],7FFFFFFFh
			.endif
		.else	;  x2  
			invoke uint_cmp,hCalc,x1,x2
			.if CARRY?	; x1<x2
				mov ebx,hCalc
				mov ecx,[ebx][CALC_DESCRIPTOR.int_length]
				mov esi,x1
				mov edi,[ebx][CALC_DESCRIPTOR.msr0]
				mov edx,ecx
				rep movsd
				mov ecx,edx
				mov esi,x2
				mov edi,x1
				rep movsd
				invoke uint_sub,ebx,x1,[ebx][CALC_DESCRIPTOR.msr0]
				mov eax,x1
				or dword ptr [eax],80000000h
			.elseif ZERO?
				mov edi,x1
				xor eax,eax
				mov ecx,[ebx][CALC_DESCRIPTOR.int_length]
				rep stosd
				ret
			.else
				invoke uint_sub,hCalc,x1,x2
			.endif
		.endif
	.endif
	mov eax,TRUE
	ret
int_add endp
;   x1==x1-x2
int_sub proc hCalc,x1,x2
	mov eax,x1
	xor dword ptr [eax],80000000h
	invoke int_add,hCalc,x1,x2
	.if eax
		mov eax,x1
		xor dword ptr [eax],80000000h
	.endif
	ret
int_sub endp
uint_mul proc uses edi esi ebx hCalc,X1,X2
LOCAL m,n,signum,result,mprs,svEsp
	mov ebx,hCalc
	mov [ebx][CALC_DESCRIPTOR.ErrFlags],0
	mov ecx,[ebx][CALC_DESCRIPTOR.int_length]
	mov edi,[ebx][CALC_DESCRIPTOR.msr0]
	shl ecx,1
	xor eax,eax	;    
	rep stosd
	sub edi,4
	mov result,edi
	mov edi,X1
	mov eax,[edi]
	mov esi,X2
	mov edx,[esi]
	mov ecx,eax
	and ecx,80000000h
	mov signum,ecx
	and eax,7FFFFFFFh
	jz Exit
	and edx,7FFFFFFFh
	jz movz
	mov m,eax
	mov n,edx
	mov ecx,[ebx][CALC_DESCRIPTOR.int_length]
	lea edx,[esi+4*ecx-4]
	mov mprs,edx
	sub ecx,eax
	lea edi,[edi+4*ecx-4]
	mov ebx,result
	shl eax,2
	sub ebx,eax
	mulm m,n,mprs,svEsp	; 
	mov edx,result
	add edx,4
	sub edx,ebx
	shr edx,2
	mov edi,X1
	mov ebx,hCalc
	mov ecx,[ebx][CALC_DESCRIPTOR.int_length]
	xor eax,eax
	rep stosd
	std
	sub edi,4
	mov esi,result
	mov ecx,edx
	mov eax,[ebx][CALC_DESCRIPTOR.int_length]
	.if edx<eax
		mov eax,edx
	.else
		or [ebx][CALC_DESCRIPTOR.ErrFlags],OVERFLOW_FLAG
		dec eax
		mov ecx,eax
	.endif
	rep movsd
	cld
	or edx,signum
	or eax,signum
	mov edi,X1
	mov [edi],eax
	mov edi,[ebx][CALC_DESCRIPTOR.msr0]
	mov [edi],edx
Exit:
	ret
movz:
	mov edi,X1
	mov ecx,[ebx][CALC_DESCRIPTOR.int_length]
	xor eax,eax
	rep stosd
	ret
uint_mul endp
;  x1<--x2
rmove proc uses edi esi hCalc,x1,x2
	mov edx,hCalc
	mov edi,x1
	mov esi,x2
	mov ecx,[edx][CALC_DESCRIPTOR.int_length]
	add ecx,[edx][CALC_DESCRIPTOR.fract_length]
	rep movsd
	ret
rmove endp
; 
rsin proc uses esi edi ebx hCalc,sine,angle,prec_sine
	mov ebx,hCalc
	mov esi,2
	mov edi,1
	invoke rmove,ebx,[ebx][CALC_DESCRIPTOR.msr7],angle
	invoke rmove,ebx,[ebx][CALC_DESCRIPTOR.msr6],angle
	invoke rmove,ebx,sine,angle
	invoke rmul,ebx,[ebx][CALC_DESCRIPTOR.msr6],angle
	.while edi<prec_sine
		invoke rmul,ebx,[ebx][CALC_DESCRIPTOR.msr7],[ebx][CALC_DESCRIPTOR.msr6]
		.break .if !eax
		mov eax,esi
		inc esi
		mul esi
		inc esi
		invoke ShortRDiv,ebx,[ebx][CALC_DESCRIPTOR.msr7],eax
		.if edi&1
			invoke rsub,ebx,sine,[ebx][CALC_DESCRIPTOR.msr7]
		.else
			invoke radd,ebx,sine,[ebx][CALC_DESCRIPTOR.msr7]
		.endif
		inc edi
	.endw
	ret
rsin endp
; 
rcos proc uses esi edi ebx hCalc,cosine,angle,prec_cosine
	mov ebx,hCalc
	mov esi,1
	mov edi,1
	invoke rmove,ebx,[ebx][CALC_DESCRIPTOR.msr6],angle
	invoke rmul,ebx,[ebx][CALC_DESCRIPTOR.msr6],angle
	xor edx,edx
	mov eax,1
	invoke uild,ebx,cosine	;cosine==1
	xor edx,edx
	mov eax,1
	invoke uild,ebx,[ebx][CALC_DESCRIPTOR.msr7]	;[ebx][CALC_DESCRIPTOR.msr7]==1
	.while edi<prec_cosine
		invoke rmul,ebx,[ebx][CALC_DESCRIPTOR.msr7],[ebx][CALC_DESCRIPTOR.msr6]
		.break .if !eax
		mov eax,esi
		inc esi
		mul esi
		inc esi
		invoke ShortRDiv,ebx,[ebx][CALC_DESCRIPTOR.msr7],eax
		.if edi&1
			invoke rsub,ebx,cosine,[ebx][CALC_DESCRIPTOR.msr7]
		.else
			invoke radd,ebx,cosine,[ebx][CALC_DESCRIPTOR.msr7]
		.endif
		inc edi
	.endw
	ret
rcos endp
;   
ralloc proc hCalc
	mov edx,hCalc
	mov eax,[edx][CALC_DESCRIPTOR.int_length]
	add eax,[edx][CALC_DESCRIPTOR.fract_length]
	invoke VirtualAlloc,NULL,eax,MEM_COMMIT,PAGE_EXECUTE_WRITECOPY
	ret
ralloc endp
; 
rfree proc hCalc,xfree
	mov edx,hCalc
	mov eax,[edx][CALC_DESCRIPTOR.int_length]
	add eax,[edx][CALC_DESCRIPTOR.fract_length]
	invoke VirtualFree,xfree,eax,MEM_DECOMMIT
	ret
rfree endp
;  
rsqrt proc uses edi esi ebx hCalc,x1,prec_sqrt
	mov eax,x1
	.if !((dword ptr [eax])&80000000h)
		mov ebx,hCalc
		mov edi,0
		invoke rmove,ebx,[ebx][CALC_DESCRIPTOR.msr5],x1
;		int 3
		.while edi<prec_sqrt
			invoke rmove,ebx,[ebx][CALC_DESCRIPTOR.msr7],x1
			invoke rmove,ebx,[ebx][CALC_DESCRIPTOR.msr6],x1
			invoke rmove,ebx,[ebx][CALC_DESCRIPTOR.msr4],[ebx][CALC_DESCRIPTOR.msr5]
			invoke rshr1,ebx,[ebx][CALC_DESCRIPTOR.msr7]
			invoke rshl1,ebx,[ebx][CALC_DESCRIPTOR.msr6]	;msr6=2*msr6
			invoke rdiv,ebx,[ebx][CALC_DESCRIPTOR.msr4],[ebx][CALC_DESCRIPTOR.msr6]
			.break .if [ebx][CALC_DESCRIPTOR.ErrFlags]&OVERFLOW_FLAG
			invoke ureal_sub,ebx,[ebx][CALC_DESCRIPTOR.msr7],[ebx][CALC_DESCRIPTOR.msr4]
			invoke ureal_sub,ebx,x1,[ebx][CALC_DESCRIPTOR.msr7]
			inc edi
		.endw
		mov eax,TRUE
	.else
		xor eax,eax
	.endif
	mov edi,x1
	and dword ptr [edi],7FFFFFFFh
	ret
rsqrt endp
r2st proc uses esi edi ebx hCalc,x1
LOCAL buff10:TBYTE
LOCAL Order
	mov ebx,hCalc
	mov esi,x1
	mov edx,[esi]
	and edx,7FFFFFFFh
	.if ZERO?
		mov ecx,[ebx][CALC_DESCRIPTOR.int_length]
		lea edi,[esi+4*ecx]
		xor eax,eax
		mov ecx,[ebx][CALC_DESCRIPTOR.fract_length]
		repe scasd
		.if ZERO?
			fldz
			ret
		.endif
		mov eax,[edi-4]
		mov Order,ecx
		bsr edx,eax
		mov ecx,31
		sub ecx,edx
		.if Order 
			.if cl
				mov edx,[edi]
				shld eax,edx,cl
				mov dword ptr buff10[4],eax
				.if Order>1
					mov eax,edx
					mov edx,[edi+4]
					shld eax,edx,cl
					mov dword ptr buff10,eax
				.else
					shl edx,cl
					mov dword ptr buff10,edx
				.endif
			.else
				mov dword ptr buff10[4],eax
				mov eax,[edi]
				mov dword ptr buff10,eax
			.endif
		.else
			.if cl
				shl eax,cl
			.endif
			mov dword ptr buff10[4],eax
			mov dword ptr buff10,0
		.endif
		mov edx,[ebx][CALC_DESCRIPTOR.fract_length]
		sub edx,Order
		dec edx
		shl edx,5
		add edx,ecx
		neg edx
		add edx,3FFEh
		.if dword ptr [esi]&80000000h
			or edx,8000h
		.endif
		mov word ptr buff10[8],dx
		fld buff10
	.else
		mov Order,edx
		mov ecx,[ebx][CALC_DESCRIPTOR.int_length]
		sub ecx,edx
		lea edi,[esi+4*ecx+4]
		mov eax,[edi-4]
		bsr edx,eax
		mov ecx,31
		sub ecx,edx
		.if cl
			mov edx,[edi]
			shld eax,edx,cl
			mov dword ptr buff10[4],eax
			mov eax,edx
			mov edx,[edi+4]
			shld eax,edx,cl
			mov dword ptr buff10,eax
		.else
			mov dword ptr buff10[4],eax
			mov eax,[edi]
			mov dword ptr buff10,eax
		.endif
		mov edx,Order
		shl edx,5
		sub edx,ecx
		add edx,3FFEh
		.if dword ptr [esi]&80000000h
			or edx,8000h
		.endif
		mov word ptr buff10[8],dx
		fld buff10
	.endif
	ret
r2st endp
st2r proc uses edi esi ebx hCalc,X
LOCAL buff10:TBYTE
LOCAL Order
	fstp buff10
	xor eax,eax
	mov ebx,hCalc
	mov ecx,[ebx][CALC_DESCRIPTOR.int_length]
	add ecx,[ebx][CALC_DESCRIPTOR.fract_length]
	mov edi,X
	rep stosd
	mov edi,X
	mov ecx,[ebx][CALC_DESCRIPTOR.int_length]
	lea esi,[edi+4*ecx]
	movzx eax,word ptr buff10[8]
	.if eax&8000h
		mov dword ptr [edi],80000000h
		and eax,7FFFh
	.endif
;	shl eax,17
;	sar eax,17
	sub eax,3FFEh
	mov Order,eax
	.if SIGN?
		neg eax
		mov Order,eax
		and eax,1Fh
		shr Order,5
		mov ecx,Order
		add ecx,2
		.if ecx>=[ebx][CALC_DESCRIPTOR.fract_length]
			mov eax,1
			ret
		.endif
		shl Order,2
		add esi,Order
		mov ecx,eax
		xor eax,eax
		mov edi,dword ptr buff10
		mov edx,dword ptr buff10[4]
		shrd eax,edi,cl
		shrd edi,edx,cl
		shr edx,cl
		mov [esi],edx
		mov [esi+4],edi
		mov [esi+8],eax
	.else
		and eax,1Fh
		shr Order,5
		shl Order,2
		sub esi,Order
		sub esi,4
		add edi,4
		.if esi<=edi
			mov eax,1
			ret
		.endif
		mov ecx,eax
		xor eax,eax
		mov edi,dword ptr buff10
		mov edx,dword ptr buff10[4]
		shld eax,edx,cl
		shld edx,edi,cl
		shl edi,cl
		mov [esi],eax
		mov [esi+4],edx
		mov [esi+8],edi
		.if eax
			mov eax,4
		.else
			xor eax,eax
		.endif
		add eax,Order
		shr eax,2
		mov edi,X
		or [edi],eax
	.endif
	xor eax,eax
	ret
st2r endp
;    
rshl1 proc uses edi esi ebx hCalc,x1
	mov ebx,hCalc
	mov edi,x1
	mov edx,[edi]
	and edx,7FFFFFFFh
	mov ecx,[ebx][CALC_DESCRIPTOR.int_length]
	sub ecx,edx
	lea edi,[edi+4*ecx]
	lea esi,[edi-4]
	sub edi,4
	mov ecx,edx
	.if esi>x1
		sub edi,4
		inc ecx
	.endif
	add ecx,[ebx][CALC_DESCRIPTOR.fract_length]
	.if !ZERO?
		.repeat	;   
			rcl dword ptr [edi+4*ecx],1
		.untilcxz
		pushfd
		.if esi>x1 && dword ptr [esi]
			mov esi,x1
			inc dword ptr [esi]
		.endif
		popfd
	.endif
	ret
rshl1 endp
;    
rshr1 proc uses edi esi ebx hCalc,x1
	mov ebx,hCalc
	mov edi,x1
	mov edx,[edi]
	and edx,7FFFFFFFh
	mov ecx,[ebx][CALC_DESCRIPTOR.int_length]
	sub ecx,edx
	lea edi,[edi+4*ecx]
	mov esi,edi
	mov ecx,edx
	add ecx,[ebx][CALC_DESCRIPTOR.fract_length]
	.if !ZERO?
		.repeat	;   
			rcr dword ptr [edi],1
			lea edi,[edi+4]
		.untilcxz
		pushfd
		.if !(dword ptr [esi])
			mov esi,x1
			.if dword ptr [esi]&7FFFFFFFh
			 	dec dword ptr [esi]
			.endif
		.endif
		popfd
	.endif
	ret
rshr1 endp
rtest proc uses ebx hCalc,x1
	mov ebx,hCalc
	mov eax,x1
	mov ecx,[eax]
	and ecx,7FFFFFFFh
	mov edx,[ebx][CALC_DESCRIPTOR.int_length]
	sub edx,ecx
	lea eax,[eax+4*edx-4]
	add ecx,[ebx][CALC_DESCRIPTOR.fract_length]
	.if !ZERO?
		.repeat
			.break .if dword ptr [eax+4*ecx]
		.untilcxz
	.endif
	ret
rtest endp
GetEngineVersion proc
	mov eax,101h
	ret
GetEngineVersion endp
end DllEntryPoint