include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
includelib \masm32\lib\kernel32.lib
init_calc proto int_length:DWORD,decseparator:DWORD,fract_length:DWORD
off_calc proto hMath:DWORD
atoiX proto hMath:DWORD,X:DWORD,Radix:DWORD
atorX proto hMath:DWORD,X:DWORD,Radix:DWORD
int_add proto hCalc:DWORD,x1:DWORD,x2:DWORD
int_sub proto hMath:DWORD,x1:DWORD,x2:DWORD
int_mul proto hCalc:DWORD,x1:DWORD,x2:DWORD
int_div proto hCalc:DWORD,x1:DWORD,x2:DWORD,Remn:DWORD
itoaX proto hMath:DWORD,X:DWORD,Radix:DWORD
fmtitoax proto hMath:DWORD,X:DWORD,Radix:DWORD,MaxNum:DWORD
fmtrtoa proto hCalc:DWORD,x1:DWORD,Radix:DWORD,MaxNum:DWORD
rtoaX proto hMath:DWORD,X:DWORD,Radix:DWORD
uint_add proto hCalc:DWORD,x1:DWORD,x2:DWORD
uint_sub proto hMath:DWORD,x1:DWORD,x2:DWORD
uint_mul proto hCalc:DWORD,x1:DWORD,x2:DWORD
uint_div proto hCalc:DWORD,x1:DWORD,x2:DWORD,Remn:DWORD
ureal_add proto hCalc:DWORD,x1:DWORD,x2:DWORD
ureal_sub proto hCalc:DWORD,x1:DWORD,x2:DWORD
ureal_cmp proto hCalc:DWORD,x1:DWORD,Radix:DWORD
ild proto hCalc:DWORD,X:DWORD
uild proto hCalc:DWORD,X:DWORD
ShortDivUx proto hCalc:DWORD,W:DWORD,V:DWORD
ShortMulUx proto hMath:DWORD,W:DWORD,V:DWORD
ShortRDiv proto hCalc:DWORD,W:DWORD,V:DWORD
ShortRMul proto hCalc:DWORD,W:DWORD,V:DWORD
recalcpi proto hCalc:DWORD,ppi:DWORD,prec_pi:DWORD
uint_cmp proto hCalc:DWORD,x1:DWORD,x2:DWORD
Factorial proto hCalc:DWORD,x1:DWORD,n:DWORD
Unfactorial proto hCalc:DWORD,x1:DWORD,Remn:DWORD,maxN:DWORD
ShortUintPow proto hCalc:DWORD,x1:DWORD,n:DWORD
_ultoa PROTO C Val :DWORD ,pBuff:DWORD,Radix:DWORD
buffuild proto hCalc:DWORD,x1:DWORD,pBuff:DWORD,szBuff:DWORD
rmul proto hCalc:DWORD,x1:DWORD,x2:DWORD
rdiv proto hCalc:DWORD,x1:DWORD,x2:DWORD
radd proto hCalc:DWORD,x1:DWORD,x2:DWORD
rsub proto hCalc:DWORD,x1:DWORD,x2:DWORD
fmtator proto hCalc:DWORD,x1:DWORD,Radix:DWORD
rmove proto hCalc:DWORD,x1:DWORD,x2:DWORD
rsin proto hCalc:DWORD,sine:DWORD,angle:DWORD,prec_sine:DWORD
rcos proto hCalc:DWORD,cosine:DWORD,angle:DWORD,prec_cosine:DWORD
ralloc proto hCalc:DWORD
rfree proto hCalc:DWORD,xfree:DWORD
rsqrt proto hCalc:DWORD,x1:DWORD,prec_sqrt:DWORD
st2r proto hCalc:DWORD,X:DWORD
r2st proto hCalc:DWORD,x1:DWORD
rshl1 proto hCalc:DWORD,x1:DWORD
rshr1 proto hCalc:DWORD,x1:DWORD
rtest proto hCalc:DWORD,x1:DWORD
GetEngineVersion proto

;        
;        
CALC_DESCRIPTOR STRUC
	calc_size dd ?	;     
	reg0 dd ?	; reg_x       
	reg1 dd ?	;     
	reg2 dd ?	;       ,     
	reg3 dd ?	;      / 
	reg4 dd ?
	reg5 dd ?
	reg6 dd ?
	reg7 dd ?
	msr0 dd ?	; msr_x        
	msr1 dd ?
	msr2 dd ?
	msr3 dd ?
	msr4 dd ?
	msr5 dd ?
	msr6 dd ?
	msr7 dd ?
	Reserved1 db ?
	Reserved2 db ?
	ErrFlags db ?
	DecimalSeparator db ?	;  ,     
	int_length dd ?			;        x86  4  DWORD`
	fract_length dd ?		;  
	ascii_buff dd ?			; /    
	size_abuff dd ?			;  /   
CALC_DESCRIPTOR ENDS

DIV_BY_ZERO equ 10b
OVERFLOW_FLAG equ 100b

;--------------------------------------------------------------------------------
;    ,     
;   .
;i -       ,   ,   
;j -       ,   ,   
;edi -       4
;mtprs -      ,   ,   
;sv_Esp -    ,   
;ebx -   (j-1)-      i+j    
;    
;   ebx    
mulm macro i,j,mtprs,sv_Esp
	mov sv_Esp,esp
	.repeat
		mov ecx,i
		mov esi,mtprs
		xor esp,esp
		mov esi,[esi]
		.repeat
			mov eax,[edi+4*ecx]
			mul esi
			add eax,esp
			adc edx,0
			add [ebx+4*ecx],eax
			adc edx,0
			mov esp,edx
		.untilcxz
		mov [ebx],edx
		sub mtprs,4
		sub ebx,4
		dec j
	.until ZERO?
	.repeat
		add ebx,4
	.until dword ptr [ebx]
	mov esp,sv_Esp
endm
;--------------------------------------------------------------------------------
;      
;edi -      4
;ecx -     
;ebx - 
;    
smulm macro
	xor esi,esi
	.repeat
		mov eax,dword ptr [edi+4*ecx]
		mul ebx
		add eax,esi
		adc edx,0
		mov esi,edx
		mov dword ptr [edi+4*ecx],eax
	.untilcxz
endm
;--------------------------------------------------------------------------------
;      
;edi -    
;ecx -     
;esi - 
;      ebx  
sdivm macro
	.repeat
		mov eax,[edi]
		div esi
		mov [edi],eax
		add edi,4
	.untilcxz
endm